﻿Namespace edank

    Public Class Comparer(Of T)
        Implements IComparer(Of T)

        Private _sortProperty As Reflection.PropertyInfo
        Private _sortDescending As Boolean

        Public Sub New(ByVal sortFieldName As String, ByVal sortDescending As Boolean)
            _sortProperty = GetType(T).GetProperty(sortFieldName)
            _sortDescending = sortDescending
        End Sub

        Public Function Compare(ByVal x As T, ByVal y As T) As Integer Implements System.Collections.Generic.IComparer(Of T).Compare
            Dim Wert1 As IComparable = DirectCast(_sortProperty.GetValue(x, Nothing), IComparable)
            ' Dim Wert1 As Object = _sortProperty.GetValue(x, Nothing)
            Dim Wert2 As Object = _sortProperty.GetValue(y, Nothing)

            ' Dim res As Integer = Wert1.CompareTo(Wert2)
            Dim res As Integer = Wert1.CompareTo(Wert2)

            If _sortDescending Then Return -res
            Return res
        End Function



    End Class
End Namespace