﻿Imports System.ComponentModel

Namespace edank

    <ToolboxBitmap(GetType(TextBox))> _
 Public Class ETextBox
        Inherits TextBox

    

        ' Interne Variablen für OnlyNumbers
        Private _UseOnlyNumbers As Boolean
        Private _UseKomma As Boolean
        Private _UsePoint As Boolean
        Private _UseDblPoint As Boolean
        Private _UseMinus As Boolean
        Private _UseHex As Boolean
        Private _UseBinary As Boolean

        Sub New()
            MyBase.New()

            _UseOnlyNumbers = False
            _UseKomma = False
            _UsePoint = False
            _UseDblPoint = False

            _UseMinus = False
            _UseHex = False
            _UseBinary = False


        End Sub


        Protected Overrides Sub OnKeyPress(ByVal e As System.Windows.Forms.KeyPressEventArgs)
            If UseOnlyNumbers Then
                If Char.IsControl(e.KeyChar) = False Then
                    If Me.TextLength - Me.SelectionLength < Me.MaxLength Then
                        e.Handled = True
                        Me.SelectedText = ChrW(CalculateKeys(AscW(e.KeyChar)))
                    End If
                End If
            End If
            MyBase.OnKeyPress(e)
        End Sub




#Region " Properties OnlyNumbers "

        Public Property UseOnlyNumbers() As Boolean
            Get
                Return _UseOnlyNumbers
            End Get
            Set(ByVal value As Boolean)
                _UseOnlyNumbers = value
            End Set
        End Property

        Public Property UseKomma() As Boolean
            Get
                Return _UseKomma
            End Get
            Set(ByVal value As Boolean)
                _UseKomma = value
            End Set
        End Property

        Public Property UsePoint() As Boolean
            Get
                Return _UsePoint
            End Get
            Set(ByVal value As Boolean)
                _UsePoint = value
            End Set
        End Property

        Public Property UseDblPoint() As Boolean
            Get
                Return _UseDblPoint
            End Get
            Set(ByVal value As Boolean)
                _UseDblPoint = value
            End Set
        End Property

        Public Property UseMinus() As Boolean
            Get
                Return _UseMinus
            End Get
            Set(ByVal value As Boolean)
                _UseMinus = value
            End Set
        End Property

        Public Property UseHex() As Boolean
            Get
                Return _UseHex
            End Get
            Set(ByVal value As Boolean)
                _UseHex = value
            End Set
        End Property

        Public Property UseBinary() As Boolean
            Get
                Return _UseBinary
            End Get
            Set(ByVal value As Boolean)
                _UseBinary = value
            End Set
        End Property

#End Region

        Private Function CalculateKeys(ByVal KeyAscii As Integer) As Integer
            If KeyAscii >= 48 AndAlso KeyAscii <= 57 Then
                If UseBinary Then
                    If KeyAscii >= 48 AndAlso KeyAscii <= 49 Then
                        Return KeyAscii
                    Else
                        Return 0
                    End If
                    Return KeyAscii
                End If
            End If
            If UseKomma Then
                If KeyAscii = 44 Then
                    Return KeyAscii
                End If
            End If
            If UsePoint Then
                If KeyAscii = 46 Then
                    Return KeyAscii
                End If
            End If
            If UseDblPoint Then
                If KeyAscii = 58 Then
                    Return KeyAscii
                End If
            End If
            If UseMinus Then
                If KeyAscii = 45 Then
                    Return KeyAscii
                End If
            End If
            If UseHex AndAlso KeyAscii >= 65 AndAlso KeyAscii <= 71 OrElse UseHex AndAlso KeyAscii >= 97 AndAlso KeyAscii <= 102 Then
                If KeyAscii >= 97 Then
                    If KeyAscii <= 102 Then
                        KeyAscii -= 32
                    End If
                End If
                Return KeyAscii
            End If
            Return 0
        End Function

    End Class


End Namespace