﻿Namespace edank.LGTV.Channels

    Public Class DVBS_Channel

        Private _DataBlock As Byte() 'gesamter DatenBlock

        '*************************
        'DatenBlock Parts
        Private tmp01() As Byte '5
        Private _TransponderID As UInt16
        Private tmp02() As Byte '1
        Private _Number As UInt16
        Private _LG_ChaosNumber As UInt16
        Private _TransponderID2 As UInt16
        Private _FavByte As Byte
        Private _SkeepLockByte As Byte
        Private _ServiceID As UInt16
        Private tmp04() As Byte '1
        Private _NameLenght As Byte
        Private _NameInFile As String
        Private _VideoPid As UInt16
        Private _AudioPid As UInt16
        Public tmp05 As UInt32  '4
        'EndDatenBlock Parts
        '****************************

        Private _ShortName As String
        Private _isRadio As Boolean
        Private _isInvisibleChannel As Boolean
        Private _isDeadChannel As Boolean

        Private _DisplayName As String
        Private _NumberInFile As UInt16

        Public Sub New(Data() As Byte)
            _DataBlock = Data
            Call DataReadIN(DataBlock)
        End Sub

        Private Sub DataReadIN(Data() As Byte)
            Dim ms As New IO.MemoryStream(_DataBlock)
            Dim br As New IO.BinaryReader(ms)
            br.BaseStream.Seek(0, IO.SeekOrigin.Begin)

            tmp01 = br.ReadBytes(5)
            _TransponderID = br.ReadUInt16
            tmp02 = br.ReadBytes(1)

            Number = br.ReadUInt16

            _LG_ChaosNumber = br.ReadUInt16
            _TransponderID2 = br.ReadUInt16

            _FavByte = br.ReadByte
            _SkeepLockByte = br.ReadByte
            _ServiceID = br.ReadUInt16

            tmp04 = br.ReadBytes(1)

            _NameLenght = br.ReadByte

            NameInFile = System.Text.Encoding.Default.GetString(br.ReadBytes(&H28))

            _VideoPid = br.ReadUInt16
            _AudioPid = br.ReadUInt16

            tmp05 = br.ReadUInt32 '(4)

            br.Close()
            ms.Close()
            ms.Dispose()


            If Me.DataBlock(18) = &HC OrElse
                Me.getBlockData.StartsWith("FF FF") OrElse
                (Me.SkeepLockByte And DVBS_Channel.ChannelSkipLockMode.InVisible) = DVBS_Channel.ChannelSkipLockMode.InVisible Then
                Me.isInvisibleChannel = True
            Else
                Me.isInvisibleChannel = False
            End If

        End Sub

#Region "Properties"

        Public ReadOnly Property DataBlock As Byte()
            Get
                Return _DataBlock
            End Get
        End Property

        Public Property TransponderID As UInt16
            Get
                Return _TransponderID
            End Get
            Set(value As UInt16)
                _TransponderID = value
            End Set
        End Property

        Public Property TransponderID2 As UInt16
            Get
                Return _TransponderID2
            End Get
            Set(value As UInt16)
                _TransponderID2 = value
            End Set
        End Property

        Public Property Number As UInt16
            Get
                If Me.isRadio Then
                    Return CUShort(_Number - &H4000)
                Else
                    Return _Number
                End If
            End Get
            Set(value As UInt16)
                If CBool(value And &H4000) Then
                    Me._isRadio = True
                End If

                If Me.isRadio Then
                    _Number = CUShort(value Or &H4000)
                Else
                    _Number = value
                End If
                _NumberInFile = _Number
            End Set
        End Property

        Public ReadOnly Property NumberInFile As UInt16
            Get
                Return _NumberInFile
            End Get
        End Property

        Public Property LG_ChaosNumber As UInt16
            Get
                Return _LG_ChaosNumber
            End Get
            Set(value As UInt16)
                _LG_ChaosNumber = value
            End Set
        End Property

        Public Property FavByte As Byte
            Get
                Return _FavByte
            End Get
            Set(value As Byte)
                _FavByte = value
            End Set
        End Property

        Public Property SkeepLockByte As Byte
            Get
                Return _SkeepLockByte
            End Get
            Set(value As Byte)
                _SkeepLockByte = value
            End Set
        End Property

        Public Property ServiceID As UInt16
            Get
                Return _ServiceID
            End Get
            Set(value As UInt16)
                _ServiceID = value
            End Set
        End Property

        Public Property NameLenght As Byte
            Get
                Return _NameLenght
            End Get
            Set(value As Byte)
                _NameLenght = value
            End Set
        End Property

        Public Property NameInFile As String
            Get
                Return _NameInFile
            End Get
            Set(value As String)
                value = value.Replace(Chr(0), "")

                _NameInFile = value

                _DisplayName = value.Replace(Chr(&H86), "").Replace(Chr(&H87), "").Replace(Chr(&H5), "").Replace(Chr(&HB), "")

                _NameLenght = CByte(value.Length)
            End Set
        End Property

        Public ReadOnly Property DisplayName As String
            Get
                Return _DisplayName
            End Get
        End Property


        Public Property VideoPid As UInt16
            Get
                Return _VideoPid
            End Get
            Set(value As UInt16)
                _VideoPid = value
            End Set
        End Property

        Public Property AudioPid As UInt16
            Get
                Return _AudioPid
            End Get
            Set(value As UInt16)
                _AudioPid = value
            End Set
        End Property

        Public ReadOnly Property isRadio As Boolean
            Get
                Return _isRadio
            End Get
        End Property

        Public Property isDeadChannel As Boolean
            Get
                Return _isDeadChannel
            End Get
            Set(value As Boolean)
                _isDeadChannel = value
            End Set
        End Property

        Public Property isInvisibleChannel As Boolean
            Get
                Return _isInvisibleChannel
            End Get
            Set(value As Boolean)
                _isInvisibleChannel = value
            End Set
        End Property

#End Region


        Public Function getBlockData() As String
            Dim r As String = ""
            For i As Integer = 0 To DataBlock.Length - 1
                r &= DataBlock(i).ToString("X2") & " "
            Next

            Return r.TrimEnd
        End Function

        Public Function getBlockDatatoSave() As String
            Dim r As String = ""
            Dim d() As Byte = getDataToSave()
            For i As Integer = 0 To d.Length - 1
                r &= d(i).ToString("X2") & " "
            Next

            Return r.TrimEnd
        End Function


        Public Enum ChannelFavoriten As Byte
            A = &H4
            B = &H8
            C = &H10
            D = &H20
        End Enum

        Public Enum ChannelSkipLockMode As Byte
            Lock = &H1
            Skip = &H2
            InVisible = &H4
        End Enum

        Public Function getListViewItem(Optional InkludeInvisibleChannels As Boolean = False, Optional InkludeDeadChannels As Boolean = False, Optional OnlyInvisibleChannels As Boolean = False) As ListViewItem
            If OnlyInvisibleChannels Then
                InkludeInvisibleChannels = True
            End If

            If InkludeInvisibleChannels = False AndAlso Me.isInvisibleChannel = True Then
                Return Nothing
            End If

            If InkludeDeadChannels = False AndAlso Me.isDeadChannel = True Then
                Return Nothing
            End If

            Dim lvw As New ListViewItem
            lvw.SubItems.Add(Me.Number.ToString)
            lvw.SubItems.Add(Me.DisplayName)
            lvw.SubItems.Add(Me.getShortName)
            lvw.SubItems.Add(Me.get_strFavoriten)
            lvw.SubItems.Add(Me.get_strSkip)
            lvw.SubItems.Add(Me.get_strLock)
            lvw.SubItems.Add(Me.ServiceID.ToString)
            lvw.SubItems.Add(Me.VideoPid.ToString)
            lvw.SubItems.Add(Me.AudioPid.ToString)
            lvw.Tag = Me
            lvw.ImageKey = If(Me.isRadio, "Radio", "TV")

            If OnlyInvisibleChannels Then
                If Me.isInvisibleChannel Then
                    Return lvw
                Else
                    Return Nothing
                End If
            End If

            Return lvw

        End Function

        Public Sub reloadListViewItem(lvw As ListViewItem)
            lvw.SubItems(1).Text = Me.Number.ToString
            lvw.SubItems(2).Text = Me.DisplayName
            lvw.SubItems(3).Text = Me.getShortName
            lvw.SubItems(4).Text = Me.get_strFavoriten
            lvw.SubItems(5).Text = Me.get_strSkip
            lvw.SubItems(6).Text = Me.get_strLock
            lvw.SubItems(7).Text = Me.ServiceID.ToString
            lvw.SubItems(8).Text = Me.VideoPid.ToString
            lvw.SubItems(9).Text = Me.AudioPid.ToString
        End Sub

        Public Function get_strFavoriten() As String
            Return If((Me.FavByte And DVBS_Channel.ChannelFavoriten.A) = DVBS_Channel.ChannelFavoriten.A, "A", "") & _
                                    If((Me.FavByte And DVBS_Channel.ChannelFavoriten.B) = DVBS_Channel.ChannelFavoriten.B, "B", "") & _
                                    If((Me.FavByte And DVBS_Channel.ChannelFavoriten.C) = DVBS_Channel.ChannelFavoriten.C, "C", "") & _
                                    If((Me.FavByte And DVBS_Channel.ChannelFavoriten.D) = DVBS_Channel.ChannelFavoriten.D, "D", "")
        End Function

        Public Function get_strSkip() As String
            Return If((Me.SkeepLockByte And DVBS_Channel.ChannelSkipLockMode.Skip) = DVBS_Channel.ChannelSkipLockMode.Skip, My.Resources.strYes, "")
        End Function

        Public Function get_strLock() As String
            Return If((Me.SkeepLockByte And DVBS_Channel.ChannelSkipLockMode.Lock) = DVBS_Channel.ChannelSkipLockMode.Lock, My.Resources.strYes, "")
        End Function

        Public Function get_strInvisible() As String
            Return If((Me.SkeepLockByte And DVBS_Channel.ChannelSkipLockMode.InVisible) = DVBS_Channel.ChannelSkipLockMode.InVisible, My.Resources.strYes, "")
        End Function

        Public Function getDataToSave() As Byte()


            Dim ms As New IO.MemoryStream()
            Dim bw As New IO.BinaryWriter(ms)

            If Me.isDeadChannel Then
                bw.Write(DataBlock)
            Else

                bw.Write(tmp01)

                bw.Write(TransponderID)

                bw.Write(tmp02)

                Dim x As Int16 = CShort(Number Or &H4000)
                If isRadio Then
                    bw.Write(x)
                Else
                    bw.Write(Number)
                End If

                bw.Write(Convert.ToUInt16(&H0)) '(LG_ChaosNumber)

                bw.Write(TransponderID2)

                bw.Write(FavByte)
                bw.Write(SkeepLockByte)
                bw.Write(ServiceID)

                bw.Write(tmp04)
                bw.Write(NameLenght)

                'Name
                For i As Integer = 0 To NameInFile.Length - 1
                    bw.Write(Convert.ToByte(Asc(NameInFile.Substring(i, 1))))
                Next
                For i As Integer = 0 To 40 - 1 - NameInFile.Length
                    bw.Write(CByte(0))
                Next

                bw.Write(VideoPid)
                bw.Write(AudioPid)
                bw.Write(tmp05)

            End If




            Return ms.ToArray()

        End Function

        Public Function getShortName() As String
            Dim r As String = String.Empty

            Dim TakeByte As Boolean = False
            For i As Integer = 0 To NameInFile.Length - 1
                If TakeByte AndAlso Asc(NameInFile.Substring(i, 1)) <> &H86 AndAlso Asc(NameInFile.Substring(i, 1)) <> &H87 AndAlso Asc(NameInFile.Substring(i, 1)) <> &H0 Then
                    r &= NameInFile.Substring(i, 1)
                End If

                If Asc(NameInFile.Substring(i, 1)) = &H86 Then
                    TakeByte = True
                End If
                If Asc(NameInFile.Substring(i, 1)) = &H87 Then
                    TakeByte = False
                End If
            Next

            Return r
        End Function

    End Class
End Namespace
