﻿Imports edankTLL.edank.LGTV.Channels
Imports edankTLL.edank.LGTV.Menu

Namespace edank.LGTV

    Public Class tll_ReadSave

        Private CurrentFile As String

        Private Const AnalogDataBlockOffset As Integer = &H4 'Fixer StartWert
        Private Const HotelMenu_DataBlockOffset As Integer = &H8753 'Addierter Wert
        Private Const DVBCT_ChannelDataBlockOffset As Integer = &H344 '&H8AB4 'Addierter Wert
        Private Const Satelitte_DataBlockOffset As Integer = &H68 '    Addierter Wert
        Private Const Transponder_DataBlockOffset As Integer = &H405C 'Addierter Wert
        Private Const DVB_ReadIN_IndexOffset As Integer = &H6 'Addierter Wert
        Private Const DVBS_ChaosTabelleOffset As Integer = &H3AC 'Addierter Wert
        Private Const DVBS_ChannelDataBlockOffset As Integer = &HEEBC - 4 'Addierter Wert

        Private AnalogTotalBlockSize As UInt32
        Private AnalogChannelCount As UInt32

        Private DVBCT_TotalBlockSize As UInt32
        Private DVBCT_ChannelCount As UInt32

        Public Const Analog_ChannelLenght As Integer = &HB8 '184
        Public Const DVBCT_ChannelLenght As Integer = &HB8 '184
        Public Const DVBS_ChannelLenght As Integer = &H44 '68
        Public Const LNB_Lenght As Integer = &H2C '44
        Public Const Hotel_Lenght As Integer = &H1D '29
        Public Const Lock_Lenght As Integer = &H4B '75
        Public Const Transponder_Lenght As Integer = &H28 '40
        Public Const ChaosTable_Lenght As Integer = &HEB00
        Public Const Satelitte_Lenght As Integer = &H2C '44

        Public Sub New(File As String)
            CurrentFile = File
            Dim fs As New IO.FileStream(File, IO.FileMode.Open)
            Dim br As New IO.BinaryReader(fs)

            Dim AfterChecksumOffset As Integer


            'Read Analog--------------------------------------------------------------------------------------------------------------
            br.BaseStream.Seek(AnalogDataBlockOffset, IO.SeekOrigin.Begin)
            AnalogTotalBlockSize = br.ReadUInt32
            AnalogChannelCount = br.ReadUInt32

            For i As Integer = 0 To CInt(AnalogChannelCount - 1)
                _Analog.Add(New Analog_Channel(br.ReadBytes(Analog_ChannelLenght)))
            Next


            'Read HotelMenu-----------------------------------------------------------------------------------------------------------
            br.BaseStream.Seek(HotelMenu_DataBlockOffset, IO.SeekOrigin.Current)
            _HotelMenu = New Hotel(br.ReadBytes(Hotel_Lenght))


            'Read DVB-CT--------------------------------------------------------------------------------------------------------------
            br.BaseStream.Seek(DVBCT_ChannelDataBlockOffset, IO.SeekOrigin.Current)
            DVBCT_TotalBlockSize = br.ReadUInt32
            DVBCT_ChannelCount = br.ReadUInt32

            For i As Integer = 0 To CInt(DVBCT_ChannelCount - 1)
                _DVBCT.Add(New DVBCT_Channel(br.ReadBytes(DVBCT_ChannelLenght)))
            Next


            'Read Satelitte-----------------------------------------------------------------------------------------------------------
            br.BaseStream.Seek(Satelitte_DataBlockOffset, IO.SeekOrigin.Current)

            For i As Integer = 0 To 23
                _Satelitte.Add(New Satelitte(br.ReadBytes(Satelitte_Lenght)))
            Next


            'Read Transponder---------------------------------------------------------------------------------------------------------
            br.BaseStream.Seek(Transponder_DataBlockOffset, IO.SeekOrigin.Current)

            For i As Integer = 0 To 2399
                _Transponder.Add(New Transponder(br.ReadBytes(Transponder_Lenght)))
                Dim t As Transponder = _Transponder(_Transponder.Count - 1)
                If t.getBlockData.StartsWith("FF FF FF FF 00 00 FF FF FF FF") OrElse t.getBlockData.StartsWith("FF FF FF FF FF FF FF FF FF FF") Then
                    _Transponder.Remove(t)
                End If
            Next


            'Read Checksum------------------------------------------------------------------------------------------------------------
            _ChecksumOffset = CInt(br.BaseStream.Position)
            _Checksum = br.ReadInt32
            AfterChecksumOffset = CInt(br.BaseStream.Position)


            'Read DVB-S Indexe and Counts----------------------------------------------------------------------------------------------
            'Chaos gleich bereinigen
            br.BaseStream.Seek(DVB_ReadIN_IndexOffset, IO.SeekOrigin.Current)
            _DVBS_ReadInIndex = br.ReadUInt16
            _DVBS_ReadInIndex2 = _DVBS_ReadInIndex
            _DVBS_ReadInCount = CUShort(Math.Min(_DVBS_ReadInIndex + 1, &HFFFF))
            If _DVBS_ReadInIndex = &HFFFF Then
                _DVBS_AbsolutEmpty = True
            Else
                _DVBS_AbsolutEmpty = False
            End If

            br.BaseStream.Seek(AfterChecksumOffset, IO.SeekOrigin.Begin)


            'Read(DVB - S)---------------------------------------------------------------------------------------------------------------
            br.BaseStream.Seek(DVBS_ChannelDataBlockOffset, IO.SeekOrigin.Current)

            For i As Integer = 0 To 7519
                _DVBS.Add(New DVBS_Channel(br.ReadBytes(DVBS_ChannelLenght)))

                Dim cs As DVBS_Channel = _DVBS.Item(_DVBS.Count - 1)

                If cs.getBlockData.StartsWith("FF FF FF FF") Then
                    _DVBS.Remove(cs)
                    Continue For
                End If

                If i > DVBS_ReadInIndex Then
                    cs.isDeadChannel = True
                Else
                    cs.isDeadChannel = False

                    '*********************************
                    'Wird in der DVB-S Klasse erledigt
                    '*********************************
                    'If cs.DataBlock(18) = &HC OrElse
                    '        cs.getBlockData.StartsWith("FF FF") OrElse
                    '        (cs.SkeepLockByte And DVBS_Channel.ChannelSkipLockMode.InVisible) = DVBS_Channel.ChannelSkipLockMode.InVisible Then
                    '    cs.isInvisibleChannel = True
                    'Else
                    '    cs.isInvisibleChannel = False
                    'End If
                End If
            Next

            For i As Integer = _DVBS.Count To 7519
                Dim x() As Byte = New Byte(DVBS_ChannelLenght - 1) {}
                For fill As Integer = 0 To x.Length - 1
                    x(fill) = 255
                Next

                _DVBS.Add(New DVBS_Channel(x))
                _DVBS.Item(_DVBS.Count - 1).isDeadChannel = True
            Next


            'Read(LNB)---------------------------------------------------------------------------------------------------------------------
            For i As Integer = 0 To 39
                _LNB.Add(New LNB(br.ReadBytes(LNB_Lenght)))
                If _LNB.Item(_LNB.Count - 1).getBlockData.StartsWith("00 00 00 00 00 00 00 00 00 00 00 00 00") Then
                    _LNB.Remove(_LNB.Item(_LNB.Count - 1))
                    Exit For
                End If
            Next

            'getData for Checksum Calculation Check
            Dim Datadvbs As Byte()
            br.BaseStream.Seek(AfterChecksumOffset, IO.SeekOrigin.Begin)
            Datadvbs = br.ReadBytes(572472)

            br.Close()
            fs.Close()
            fs.Dispose()

            Me.calculateNewChecksum(Datadvbs)

            Me.sortChannel(tll_ReadSave.ChannelType.DVBS)


        End Sub


        Public Sub SaveToFile(File As String)
            If File = String.Empty Then
                File = CurrentFile
            End If

            Dim ofs As New IO.FileStream(CurrentFile, IO.FileMode.Open)
            Dim obr As New IO.BinaryReader(ofs)

            Dim tmp1() As Byte  'Block vor AnaLogChannels
            Dim tmp2() As Byte  'Block zwischen AnalogChannels und Hotelmenü
            Dim tmp3() As Byte  'Block zwischen Hotelmenü und DVB-CT
            Dim tmp4() As Byte  'Block zwischen DVB-T und Checksum
            Dim tmp5() As Byte  'Block zwischen Checksum und DVBS_ReadInIndexe
            Dim tmp6() As Byte  'Block zwischen DVBS_ReadInIndexe und Chaostable
            Dim tmp7() As Byte  'Block nach DVB-S


            'Block vor AnaLogChannels
            obr.BaseStream.Seek(0, IO.SeekOrigin.Begin)
            tmp1 = obr.ReadBytes(AnalogDataBlockOffset)

            'Block zwischen AnalogChannels und Hotelmenü
            obr.BaseStream.Seek(AnalogTotalBlockSize + 4, IO.SeekOrigin.Current)
            tmp2 = obr.ReadBytes(HotelMenu_DataBlockOffset)

            'Block zwischen Hotelmenü und DVB-CT
            obr.BaseStream.Seek(Hotel_Lenght, IO.SeekOrigin.Current)
            tmp3 = obr.ReadBytes(DVBCT_ChannelDataBlockOffset)



            'Block zwischen DVB-CT und Checksum
            obr.BaseStream.Seek(DVBCT_TotalBlockSize + 4, IO.SeekOrigin.Current)
            tmp4 = (obr.ReadBytes(Satelitte_DataBlockOffset _
                                + (Satelitte_Lenght * 24) _
                                + Transponder_DataBlockOffset _
                                + (Transponder_Lenght * 2400))) 'ChecksumLenght




            'Block zwischen Checksum und DVBS_ReadInIndexe
            obr.BaseStream.Seek(4, IO.SeekOrigin.Current) 'Checksum überspringen
            tmp5 = obr.ReadBytes(DVB_ReadIN_IndexOffset)

            'Block zwischen DVBS_ReadInIndexe und Chaostable
            obr.BaseStream.Seek(DVB_ReadIN_IndexOffset, IO.SeekOrigin.Current) 'Checksum überspringen
            tmp6 = obr.ReadBytes(DVBS_ChaosTabelleOffset)



            'Block nach DVB-S
            obr.BaseStream.Seek(ChaosTable_Lenght + DVBS_ChannelLenght * 7520, IO.SeekOrigin.Current)
            tmp7 = obr.ReadBytes(CInt(obr.BaseStream.Length - obr.BaseStream.Position))


            ofs.Flush()
            obr.Close()
            ofs.Close()
            ofs.Dispose()



            'Calculate New Checksum-------------------------------------------------------------------------------------------------------------------------
            Dim DataForChecksum(tmp5.Length + _
                                BitConverter.GetBytes(DVBS_ReadInIndex).Length + _
                                BitConverter.GetBytes(DVBS_ReadInIndex2).Length + _
                                BitConverter.GetBytes(DVBS_ReadInCount).Length + _
                                tmp6.Length + _
                                Me.getNewChaosTable.Length + _
                                (DVBS_ChannelLenght * DVBS.Count) - 1) As Byte
            Dim DestIndex As Integer = 0

            Array.Copy(tmp5, 0, DataForChecksum, DestIndex, tmp5.Length)
            DestIndex += tmp5.Length

            Array.Copy(BitConverter.GetBytes(DVBS_ReadInIndex), 0, DataForChecksum, DestIndex, BitConverter.GetBytes(DVBS_ReadInIndex).Length)
            DestIndex += BitConverter.GetBytes(DVBS_ReadInIndex).Length

            Array.Copy(BitConverter.GetBytes(DVBS_ReadInIndex2), 0, DataForChecksum, DestIndex, BitConverter.GetBytes(DVBS_ReadInIndex2).Length)
            DestIndex += BitConverter.GetBytes(DVBS_ReadInIndex2).Length

            Array.Copy(BitConverter.GetBytes(DVBS_ReadInCount), 0, DataForChecksum, DestIndex, BitConverter.GetBytes(DVBS_ReadInCount).Length)
            DestIndex += BitConverter.GetBytes(DVBS_ReadInCount).Length

            Array.Copy(tmp6, 0, DataForChecksum, DestIndex, tmp6.Length)
            DestIndex += tmp6.Length

            Array.Copy(Me.getNewChaosTable, 0, DataForChecksum, DestIndex, Me.getNewChaosTable.Length)
            DestIndex += Me.getNewChaosTable.Length


            For i As Integer = 0 To DVBS.Count - 1
                Dim ao As Integer = (DestIndex + (i * DVBS_ChannelLenght))
                Array.Copy(DVBS(i).getDataToSave, 0, DataForChecksum, ao, DVBS_ChannelLenght)
            Next

            calculateNewChecksum(DataForChecksum)
            Checksum = NewChecksum
            '------------------------------------------------------------------------------------------------------------------------------------------------



            'Dim DataForChecksum(tmp6.Length + (DVBS_ChannelLenght * DVBS.Count) - 1) As Byte
            'Array.Copy(tmp6, 0, DataForChecksum, 0, tmp6.Length)
            'For i As Integer = 0 To DVBS.Count - 1
            '    Dim ao As Integer = (tmp6.Length + (i * DVBS_ChannelLenght))
            '    Array.Copy(DVBS(i).getDataToSave, 0, DataForChecksum, ao, DVBS_ChannelLenght)
            'Next
            'calculateNewChecksum(DataForChecksum)
            'Checksum = NewChecksum


            Dim nfs As New IO.FileStream(File, IO.FileMode.Create)
            Dim nbr As New IO.BinaryWriter(nfs)

            'Write tmp1
            nbr.Write(tmp1)

            'Write Analog
            nbr.Write(getAnalog_TotalBlockSize)
            nbr.Write(getAnalogChannelCount)

            For i As Integer = 0 To Analog.Count - 1
                nbr.Write(Analog.Item(i).getDataToSave)
            Next

            'Write tmp2
            nbr.Write(tmp2)

            'Write HotelMenu
            nbr.Write(HotelMenu.getDataToSave)

            'Write tmp3
            nbr.Write(tmp3)

            'Write DVB-CT
            nbr.Write(getDVBCT_TotalBlockSize)
            nbr.Write(getDVBCTChannelCount)

            For i As Integer = 0 To DVBCT.Count - 1
                nbr.Write(DVBCT.Item(i).getDataToSave)
            Next

            'Write tmp4
            nbr.Write(tmp4)

            'Write Checksum
            If DVBS_AbsolutEmpty = False Then
                nbr.Write(NewChecksum)
            Else
                nbr.Write(Convert.ToUInt16(&HFFFF))
                nbr.Write(Convert.ToUInt16(&HFFFF))
            End If

            'Write tmp5
            nbr.Write(tmp5)

            'Write Index1
            nbr.Write(DVBS_ReadInIndex)
            nbr.Write(DVBS_ReadInIndex2)
            nbr.Write(DVBS_ReadInCount)

            'Write tmp6
            nbr.Write(tmp6)

            'Write ChaosTable
            nbr.Write(Me.getNewChaosTable)

            'Write DVB-S
            For i As Integer = 0 To DVBS.Count - 1
                nbr.Write(DVBS.Item(i).getDataToSave)
                'Debug.Print(DVBS.Item(i).getBlockDatatoSave)
            Next

            'Write tmp6
            nbr.Write(tmp7)


            nbr.Flush()
            nbr.Close()
            nfs.Close()
            nfs.Dispose()

            'muß angepasst werden damit beim erneuten speichern die Richtige Blocklängen und Counts verwendet werden.(Analog und DVBCT)
            AnalogTotalBlockSize = getAnalog_TotalBlockSize()
            AnalogChannelCount = getAnalogChannelCount()
            DVBCT_TotalBlockSize = getDVBCT_TotalBlockSize()
            DVBCT_ChannelCount = getDVBCTChannelCount()

        End Sub

        Private Function getAnalog_TotalBlockSize() As UInt32
            Return CUInt(Analog.Count * Analog_ChannelLenght + 4)
        End Function

        Private Function getAnalogChannelCount() As UInt32
            Return CUInt(Analog.Count)
        End Function

        Private Function getDVBCT_TotalBlockSize() As UInt32
            Return CUInt(DVBCT.Count * DVBCT_ChannelLenght + 4)
        End Function

        Private Function getDVBCTChannelCount() As UInt32
            Return CUInt(DVBCT.Count)
        End Function


        Private _HotelMenu As Hotel
        Public ReadOnly Property HotelMenu As Hotel
            Get
                Return _HotelMenu
            End Get
        End Property

        Private _Analog As New List(Of Analog_Channel)
        Public Property Analog As List(Of Analog_Channel)
            Get
                Return _Analog
            End Get
            Set(value As List(Of Analog_Channel))
                _Analog = value
            End Set
        End Property

        Private _DVBCT As New List(Of DVBCT_Channel)
        Public Property DVBCT As List(Of DVBCT_Channel)
            Get
                Return _DVBCT
            End Get
            Set(value As List(Of DVBCT_Channel))
                _DVBCT = value
            End Set
        End Property

        Private _DVBS As New List(Of DVBS_Channel)
        Public Property DVBS As List(Of DVBS_Channel)
            Get
                Return _DVBS
            End Get
            Set(value As List(Of DVBS_Channel))
                _DVBS = value
            End Set
        End Property

        Private _Transponder As New List(Of Transponder)
        Public Property Transponder As List(Of Transponder)
            Get
                Return _Transponder
            End Get
            Set(value As List(Of Transponder))
                _Transponder = value
            End Set
        End Property

        Private _Satelitte As New List(Of Satelitte)
        Public Property Satelitte As List(Of Satelitte)
            Get
                Return _Satelitte
            End Get
            Set(value As List(Of Satelitte))
                _Satelitte = value
            End Set
        End Property

        Private _LNB As New List(Of LNB)
        Public Property LNB As List(Of LNB)
            Get
                Return _LNB
            End Get
            Set(value As List(Of LNB))
                _LNB = value
            End Set
        End Property

        Public Function getChannelCount(Type As ChannelType, Optional isRadio As Boolean = False, Optional isInvisible As Boolean = False) As Integer
            Dim n As Integer = 0

            Select Case True
                Case Type = ChannelType.Analog
                    For i As Integer = 0 To Analog.Count - 1
                        If Analog.Item(i).isRadio = isRadio Then
                            n += 1
                        End If
                    Next
                Case Type = ChannelType.DVBCT
                    For i As Integer = 0 To DVBCT.Count - 1
                        If DVBCT.Item(i).isRadio = isRadio Then
                            n += 1
                        End If
                    Next
                Case Type = ChannelType.DVBS
                    For i As Integer = 0 To DVBS.Count - 1
                        If DVBS.Item(i).isInvisibleChannel = isInvisible Then
                            If DVBS.Item(i).isRadio = isRadio Then
                                If DVBS.Item(i).isDeadChannel = False AndAlso DVBS.Item(i).isInvisibleChannel = False Then
                                    n += 1
                                End If
                            End If
                        End If
                    Next
            End Select

            Return n
        End Function

        Public Function getDVBSChannelCount(Optional isInvisible As Boolean = False) As Integer
            Dim c As Integer = 0
            For Each ds As DVBS_Channel In Me.DVBS
                If ds.isDeadChannel = False Then
                    If ds.isInvisibleChannel = isInvisible Then
                        c += 1
                    End If
                End If
            Next

            Return c
        End Function

        Public Enum ChannelType As Byte
            Analog = 0
            DVBCT = 1
            DVBS = 2
        End Enum


        Private _Checksum As Int32
        Public Property Checksum As Int32
            Get
                Return _Checksum
            End Get
            Set(value As Int32)
                _Checksum = value
                _isChecksumCalculated = (_Checksum = _NewChecksum)
            End Set
        End Property

        Private _NewChecksum As Int32
        Public Property NewChecksum As Int32
            Get
                Return _NewChecksum
            End Get
            Set(value As Int32)
                _NewChecksum = value
                _isChecksumCalculated = (_Checksum = _NewChecksum)
            End Set
        End Property

        Private _isChecksumCalculated As Boolean

        Public ReadOnly Property isChecksumCalculated As Boolean
            Get
                Return _isChecksumCalculated
            End Get
        End Property


        Private _ChecksumOffset As Integer
        Public Property ChecksumOffset As Integer
            Get
                Return _ChecksumOffset
            End Get
            Set(value As Integer)
                _ChecksumOffset = value
            End Set
        End Property

        Private _DVBS_ReadInIndex As UInt16
        Public Property DVBS_ReadInIndex As UInt16
            Get
                Return _DVBS_ReadInIndex
            End Get
            Set(value As UInt16)
                _DVBS_ReadInIndex = value
            End Set
        End Property

        Private _DVBS_ReadInIndex2 As UInt16
        Public Property DVBS_ReadInIndex2 As UInt16
            Get
                Return _DVBS_ReadInIndex2
            End Get
            Set(value As UInt16)
                _DVBS_ReadInIndex2 = value
            End Set
        End Property

        Private _DVBS_ReadInCount As UInt16
        Public Property DVBS_ReadInCount As UInt16
            Get
                Return _DVBS_ReadInCount
            End Get
            Set(value As UInt16)
                _DVBS_ReadInCount = value
            End Set
        End Property

        Private _DVBS_AbsolutEmpty As Boolean
        Public Property DVBS_AbsolutEmpty As Boolean
            Get
                Return _DVBS_AbsolutEmpty
            End Get
            Set(value As Boolean)
                _DVBS_AbsolutEmpty = value
            End Set
        End Property


        Public Sub DeleteChannel(c As Object, ct As ChannelType)
            Select Case True
                Case ct = ChannelType.Analog
                    Me.Analog.Remove(DirectCast(c, Analog_Channel))
                Case ct = ChannelType.DVBCT
                    Me.DVBCT.Remove(DirectCast(c, DVBCT_Channel))
                Case ct = ChannelType.DVBS
                    Dim cs As DVBS_Channel = DirectCast(c, DVBS_Channel)
                    cs.SkeepLockByte = cs.SkeepLockByte Or DVBS_Channel.ChannelSkipLockMode.InVisible
                    cs.isInvisibleChannel = True
                    DVBS.Remove(cs)
                    DVBS.Insert(getDVBSChannelCount(False) + getDVBSChannelCount(True), cs)
            End Select
        End Sub



        Public Function checkNumberDuppletten() As String
            If DVBS_AbsolutEmpty Then Return String.Empty

            Dim Info As String = String.Empty
            Dim InfoAnalog As String = String.Empty
            Dim InfoDVBCT As String = String.Empty
            Dim InfoDVBS As String = String.Empty

            Dim c As Integer

            For i As Integer = 0 To DVBCT.Count - 2

                c = If(DVBCT.Item(i).isRadio, DVBCT.Item(i).Number Or &H4000, DVBCT.Item(i).Number)

                For ii As Integer = i + 1 To DVBCT.Count - 1
                    If If(DVBCT.Item(ii).isRadio, DVBCT.Item(ii).Number Or &H4000, DVBCT.Item(ii).Number) = c Then
                        If InfoDVBCT = String.Empty Then
                            InfoDVBCT = My.Resources.str3 & vbCrLf & vbCrLf
                        End If

                        If InfoDVBCT.Length > 200 Then
                            Exit For
                        Else
                            InfoDVBCT &= String.Format("{0}: ""{1}"" und ""{2}""", c.ToString("0000"), DVBCT.Item(i).DisplayName, DVBCT.Item(ii).DisplayName) & vbCrLf
                        End If


                        Exit For
                    End If

                Next
                If InfoDVBCT.Length > 200 Then
                    InfoDVBCT &= My.Resources.str5 & vbCrLf
                    Exit For
                End If
            Next

            For i As Integer = 0 To Analog.Count - 2

                c = If(Analog.Item(i).isRadio, Analog.Item(i).Number Or &H4000, Analog.Item(i).Number)

                For ii As Integer = i + 1 To Analog.Count - 1
                    If If(Analog.Item(ii).isRadio, Analog.Item(ii).Number Or &H4000, Analog.Item(ii).Number) = c Then
                        If InfoAnalog = String.Empty Then
                            InfoAnalog = My.Resources.str2 & vbCrLf & vbCrLf
                        End If

                        If InfoAnalog.Length > 200 Then
                            Exit For
                        Else
                            InfoAnalog &= String.Format("{0}: ""{1}"" und ""{2}""", c.ToString("0000"), Analog.Item(i).DisplayName, Analog.Item(ii).DisplayName) & vbCrLf
                        End If

                        Exit For
                    End If

                Next
                If InfoAnalog.Length > 200 Then
                    InfoAnalog &= My.Resources.str5 & vbCrLf
                    Exit For
                End If
            Next

            For i As Integer = 0 To DVBS_ReadInIndex - 1 ' Analog.Count - 2

                c = If(DVBS.Item(i).isRadio, DVBS.Item(i).Number Or &H4000, DVBS.Item(i).Number)

                For ii As Integer = i + 1 To DVBS_ReadInIndex 'Analog.Count - 1
                    If If(DVBS.Item(ii).isRadio, DVBS.Item(ii).Number Or &H4000, DVBS.Item(ii).Number) = c Then
                        If InfoDVBS = String.Empty Then
                            InfoDVBS = My.Resources.str1 & vbCrLf & vbCrLf
                        End If


                        If InfoDVBS.Length > 200 Then
                            Exit For
                        Else
                            InfoDVBS &= String.Format("{0}: ""{1}"" und ""{2}""", c.ToString("0000"), DVBS.Item(i).DisplayName, DVBS.Item(ii).DisplayName) & vbCrLf
                        End If


                        Exit For
                    End If

                Next
                If InfoDVBS.Length > 200 Then
                    InfoDVBS &= My.Resources.str5 & vbCrLf
                    Exit For
                End If
            Next



            Info = InfoAnalog

            If Info <> String.Empty Then
                Info &= vbCrLf & InfoDVBCT
            Else
                Info &= InfoDVBCT
            End If

            If Info <> String.Empty Then
                Info &= vbCrLf & InfoDVBS
            Else
                Info &= InfoDVBS
            End If

            If Info <> String.Empty Then
                Info &= vbCrLf & My.Resources.str4
            End If

            Return Info
        End Function

        Public Sub reNumberChannels(isRadio As Boolean, ct As ChannelType, Optional StartNumber As UInt16 = 1)
            Dim n As UInt16 = StartNumber

            Select Case True
                Case ct = ChannelType.Analog

                    For i As Integer = 0 To Analog.Count - 1
                        If Analog.Item(i).isRadio = isRadio Then
                            Analog.Item(i).Number = n
                            n = CUShort(n + 1)
                        End If
                    Next

                Case ct = ChannelType.DVBCT

                    For i As Integer = 0 To DVBCT.Count - 1
                        If DVBCT.Item(i).isRadio = isRadio Then
                            DVBCT.Item(i).Number = n
                            n = CUShort(n + 1)
                        End If
                    Next

                Case ct = ChannelType.DVBS
                    'Radio muß bei DVBS mitnummeriert werden
                    'die RadioNummer wird in der DVB-S Klasse richtig gesetzt (or &h4000)
                    Dim nRadio As UInt16 = StartNumber


                    For i As Integer = 0 To DVBS_ReadInIndex 'DVBCT.Count - 1
                        If DVBS.Item(i).isRadio Then
                            DVBS.Item(i).Number = nRadio
                            nRadio = CUShort(nRadio + 1)
                        Else
                            DVBS.Item(i).Number = n
                            n = CUShort(n + 1)
                        End If
                    Next

            End Select

        End Sub

        Public Sub sortChannel(ct As ChannelType)
            Select Case True
                Case ct = ChannelType.Analog
                    Me.Analog.Sort(New Comparer(Of Analog_Channel)("Number", False))
                Case ct = ChannelType.DVBCT
                    Me.DVBCT.Sort(New Comparer(Of DVBCT_Channel)("Number", False))
                Case ct = ChannelType.DVBS
                    Me.DVBS.Sort(New Comparer(Of DVBS_Channel)("isDeadChannel", False))
                    Me.DVBS.Sort(0, Me.getDVBSChannelCount + Me.getDVBSChannelCount(True), New Comparer(Of DVBS_Channel)("isInvisibleChannel", False))
                    Me.DVBS.Sort(0, Me.getDVBSChannelCount, New Comparer(Of DVBS_Channel)("NumberInFile", False))
            End Select
        End Sub




        Public Function getTransponderById(i As UInt16) As Transponder
            Dim rt As Transponder = Nothing
            For Each t As Transponder In Transponder
                If t.ID = i Then
                    rt = t
                    Exit For
                End If
            Next
            Return rt

        End Function


        Public Function getSatelitteByIndex(i As Byte) As Satelitte
            Dim rs As Satelitte = Satelitte(i)
            Return rs
        End Function

        Public Function getLNB_ByIndex(i As Byte) As LNB
            Dim rl As LNB = Nothing

            For Each l As LNB In LNB
                If l.SatelitteID = i Then
                    rl = l
                    Exit For
                End If
            Next

            Return rl
        End Function

        Public Sub calculateNewChecksum(Data As Byte())
            Dim crc As New CRC32()
            NewChecksum = crc.GetCrc32(New System.IO.MemoryStream(Data))
        End Sub


        Public Function getNewChaosTable() As Byte()
            Dim ms As New IO.MemoryStream()
            Dim bw As New IO.BinaryWriter(ms)
            Dim DVBsIndex As Integer = getDVBSChannelCount() + getDVBSChannelCount(True) - 1
            Dim TotalSize As Integer = &HEB00


            For i As Integer = 0 To DVBsIndex

                If i = 0 Then
                    bw.Write(Convert.ToUInt16(&HFFFF))
                    bw.Write(Convert.ToUInt16(i + 1))
                Else
                    bw.Write(Convert.ToUInt16(i - 1))
                    If i = DVBsIndex Then
                        bw.Write(Convert.ToUInt16(&HFFFF))
                    Else
                        bw.Write(Convert.ToUInt16(i + 1))
                    End If
                End If
                bw.Write(Convert.ToUInt16(i))
                bw.Write(Convert.ToUInt16(0))
            Next

            For i As Integer = ms.ToArray.Length To TotalSize - 1
                If _DVBS_AbsolutEmpty Then
                    bw.Write(Convert.ToByte(&HFF))
                Else
                    bw.Write(Convert.ToByte(0))
                End If
            Next

            Return ms.ToArray()
        End Function




        'Debug und Test######################################################################################################################################################################

        'Public Sub UnknownDoubleChannelNumber()
        '    For Each sc As DVBS_Channel In DVBS
        '        If sc.isRadio = False Then
        '            If sc.LG_ChaosNumber <> 0 Then
        '                If sc.LG_ChaosNumber <> sc.Number Then
        '                    Debug.Print(String.Format("ChannelName {0}{1}Number {2} unknown No {3}", sc.DisplayName, Space(22 - sc.DisplayName.Length), sc.Number, sc.LG_ChaosNumber))
        '                End If
        '            End If
        '        End If
        '    Next

        'End Sub


        'Test TV hat zwar keine Sender mehr
        'Nach erneutem Suchlauf werden sie zwar alle gefunden.
        'TV zeigt aber keine Namen an
        'TV Neustart: TV sagt sowas ähnliches wie Speicher verwf. (verworfen oder verwerfen)
        'Public Sub TotalResetOfDVBS()
        '    'For i As Integer = 0 To DVBS.Count - 1
        '    '    DVBS(i).Destroy()
        '    'Next
        'End Sub

        Public Function getDVBSChannels_TransponderById(i As UInt16) As List(Of DVBS_Channel)
            Dim x As New List(Of DVBS_Channel)

            For Each sc As DVBS_Channel In DVBS
                If sc.TransponderID = i Then
                    x.Add(sc)
                End If

            Next

            Return x

        End Function








    End Class

End Namespace