﻿Namespace edank

    Public Class ListViewColumnSorter

        Implements System.Collections.IComparer
        Private ColumnToSort As Integer
        Private OrderOfSort As SortOrder
        Private DateSort As Boolean
        Private NumericSort As Boolean
        Private ObjectCompare As CaseInsensitiveComparer
        Private compareResult As Integer

        Friend Sub New()
            ' Initialize the column to '0'.
            ColumnToSort = 0
            ' Initialize the sort order to 'none'.
            OrderOfSort = SortOrder.None
            ObjectCompare = New CaseInsensitiveComparer
        End Sub

        Friend Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements IComparer.Compare
            Dim strx As String = DirectCast(x, ListViewItem).SubItems(ColumnToSort).Text
            Dim stry As String = DirectCast(y, ListViewItem).SubItems(ColumnToSort).Text
            Select Case True
                Case isDateColumn
                    If IsDate(strx) = False OrElse IsDate(stry) = False Then
                        If IsDate(strx) = False AndAlso IsDate(stry) Then
                            compareResult = -1
                            Exit Select
                        End If
                        If IsDate(strx) AndAlso IsDate(stry) = False Then
                            compareResult = 1
                        End If
                    Else
                        compareResult = ObjectCompare.Compare(CDate(strx).Ticks, CDate(stry).Ticks)
                    End If
                Case isNumericColumn
                    If strx = "" Then strx = "0"
                    If stry = "" Then stry = "0"
                    compareResult = ObjectCompare.Compare(CInt(strx), CInt(stry))
                Case Else
                    compareResult = ObjectCompare.Compare(strx, stry)
            End Select

            If (OrderOfSort = SortOrder.Ascending) Then
                Return compareResult
            ElseIf (OrderOfSort = SortOrder.Descending) Then
                Return (-compareResult)
            Else
                Return 0
            End If
        End Function

        Friend Property SortColumn() As Integer
            Set(ByVal Value As Integer)
                ColumnToSort = Value
            End Set
            Get
                Return ColumnToSort
            End Get
        End Property

        Friend Property Order() As SortOrder
            Set(ByVal Value As SortOrder)
                OrderOfSort = Value
            End Set
            Get
                Return OrderOfSort
            End Get
        End Property

        Friend Property isDateColumn() As Boolean
            Set(ByVal Value As Boolean)
                DateSort = Value
            End Set
            Get
                Return DateSort
            End Get
        End Property

        Friend Property isNumericColumn() As Boolean
            Set(ByVal Value As Boolean)
                NumericSort = Value
            End Set
            Get
                Return NumericSort
            End Get
        End Property
    End Class

End Namespace