﻿Namespace edank
    Public Class Print
        Friend Shared Sub ReportHeader(ByVal e As System.Drawing.Printing.PrintPageEventArgs, ByVal Titel As String, Optional ByVal SubTitel As String = "", Optional ByVal Datum$ = "")
            Dim myString As String = String.Empty
            Dim myMargin_Y1 As Single = e.MarginBounds.Y
            Dim prtMargin_X1 As Single = e.MarginBounds.X
            Dim prtMargin_W As Single = e.MarginBounds.Width
            Dim prtVerCalc1 As Single
            Dim prtFont_1 As New Font("arial", 24, FontStyle.Regular)
            Dim prtFont_2 As New Font("arial", 12, FontStyle.Regular)
            Dim prtFont_3 As New Font("arial", 8, FontStyle.Regular)
            Dim gr As Graphics = e.Graphics
            Dim myRectangle As RectangleF
            Dim formatRight As New StringFormat
            Dim formatCenter As New StringFormat

            formatRight.Alignment = StringAlignment.Far
            formatCenter.Alignment = StringAlignment.Center

            formatCenter.FormatFlags = StringFormatFlags.MeasureTrailingSpaces
            formatRight.FormatFlags = StringFormatFlags.MeasureTrailingSpaces

            myRectangle = New RectangleF(prtMargin_X1, prtVerCalc1 + prtFont_1.Height, prtMargin_W, prtFont_1.Height)
            gr.DrawString(Titel, prtFont_1, Brushes.Black, myRectangle, formatCenter)
            prtVerCalc1 = myMargin_Y1 + prtFont_1.Height

            If SubTitel.Length > 0 Then
                Dim strHelp() As String = Split(SubTitel, vbCrLf, , CompareMethod.Text)
                Dim h As Integer = prtFont_3.Height * strHelp.Length
                myRectangle = New RectangleF(prtMargin_X1, prtVerCalc1, prtMargin_W, h)
                gr.DrawString(SubTitel, prtFont_3, Brushes.Black, myRectangle, formatCenter)
                prtVerCalc1 += h
            End If

            If Datum = vbNullString Then
                Datum = Date.Today.ToShortDateString
            End If
            ' myString = String.Format("{0} am {1}", DocSettings.Ort, Datum)

            myRectangle = New RectangleF(prtMargin_X1, prtVerCalc1, prtMargin_W, prtFont_2.Height)
            gr.DrawString(myString, prtFont_2, Brushes.Black, myRectangle, formatRight)

            prtFont_1.Dispose()
            prtFont_2.Dispose()
            prtFont_3.Dispose()
            formatRight.Dispose()
            formatCenter.Dispose()
        End Sub

        Friend Shared Sub PageHeader(ByVal e As System.Drawing.Printing.PrintPageEventArgs, ByVal posx() As Integer, ByVal ColName() As String, ByVal myPage As Integer, ByVal Algin() As DataAlgin, Optional ByVal DataHeaderFontSize As Integer = 12)
            Dim myMargin_Y1 As Integer = e.MarginBounds.Y
            Dim prtMargin_X1 As Integer = e.MarginBounds.X
            Dim prtMargin_W As Integer = e.MarginBounds.Width
            Dim prtVerCalc1 As Integer
            Dim gr As Graphics = e.Graphics
            Dim fntTemp As New Font("arial", 24, FontStyle.Regular)
            Dim fntHeader As New Font("arial", DataHeaderFontSize, FontStyle.Bold)
            Dim fntPageCount As New Font("arial", 8, FontStyle.Regular)
            Dim prtPen_1 As New Pen(System.Drawing.Color.Black, 2)
            Dim myRectangle As RectangleF
            Dim formatLeft As New StringFormat
            Dim formatCenter As New StringFormat
            Dim formatRight As New StringFormat
            Dim colIndex As Integer = posx.Length - 1

            formatLeft.Alignment = StringAlignment.Near
            formatCenter.Alignment = StringAlignment.Center
            formatRight.Alignment = StringAlignment.Far

            formatLeft.FormatFlags = StringFormatFlags.MeasureTrailingSpaces
            formatCenter.FormatFlags = StringFormatFlags.MeasureTrailingSpaces
            formatRight.FormatFlags = StringFormatFlags.MeasureTrailingSpaces

            If myPage = 1 Then
                prtVerCalc1 = myMargin_Y1 + 20
                myRectangle = New RectangleF(prtMargin_X1, prtVerCalc1, prtMargin_W, fntPageCount.Height)
                gr.DrawString(String.Format("{0} - {1}", My.Resources.strReportPage, myPage), fntPageCount, Brushes.Black, myRectangle, formatCenter)
                prtVerCalc1 += fntPageCount.Height + 10
            Else
                myRectangle = New RectangleF(prtMargin_X1, prtVerCalc1 + fntTemp.Height, prtMargin_W, fntPageCount.Height)
                gr.DrawString(String.Format("{0} - {1}", My.Resources.strReportPage, myPage), fntPageCount, Brushes.Black, myRectangle, formatCenter)
                prtVerCalc1 += fntPageCount.Height + 10 + fntTemp.Height
            End If




            For i As Integer = 0 To colIndex
                Dim w As Single = 0
                If i < colIndex Then
                    w = CSng((posx(CInt(i + 1)) - posx(CInt(i))) * 2.54) - 5
                Else
                    w = CSng(CSng(prtMargin_W) - (posx(CInt(i))) * 2.54) - 5
                End If

                myRectangle = New RectangleF(prtMargin_X1 + CSng((posx(CInt(i))) * 2.54), prtVerCalc1, w, fntHeader.Height)
                Select Case True
                    Case Algin(CInt(i)) = Nothing
                        gr.DrawString(ColName(CInt(i)), fntHeader, Brushes.Black, myRectangle, formatLeft)
                    Case Algin(CInt(i)) = DataAlgin.Left
                        gr.DrawString(ColName(CInt(i)), fntHeader, Brushes.Black, myRectangle, formatLeft)
                    Case Algin(CInt(i)) = DataAlgin.Center
                        gr.DrawString(ColName(CInt(i)), fntHeader, Brushes.Black, myRectangle, formatCenter)
                    Case Algin(CInt(i)) = DataAlgin.Right
                        gr.DrawString(ColName(CInt(i)), fntHeader, Brushes.Black, myRectangle, formatRight)
                End Select
            Next
            prtVerCalc1 += fntHeader.Height
            gr.DrawLine(prtPen_1, prtMargin_X1, prtVerCalc1, prtMargin_X1 + prtMargin_W, prtVerCalc1)

            fntTemp.Dispose()
            fntHeader.Dispose()
            fntPageCount.Dispose()
            prtPen_1.Dispose()
            formatLeft.Dispose()
            formatCenter.Dispose()
            formatRight.Dispose()
        End Sub

        Friend Shared Function ReportData(ByVal e As System.Drawing.Printing.PrintPageEventArgs, ByVal posx() As Integer, ByVal ColName() As String, ByVal ColData() As String, ByVal Algin() As DataAlgin, prtstarted As Boolean) As Boolean
            Dim prtMargin_X1 As Single = e.MarginBounds.X
            Dim prtMargin_W As Integer = e.MarginBounds.Width
            Dim prtMargin_X2 As Single = e.MarginBounds.X + e.MarginBounds.Width
            Static prtVerCalc1 As Single
            Dim maxHeight As Single
            Dim gr As Graphics = e.Graphics
            Dim fntTemp As New Font("arial", 24, FontStyle.Regular)
            Dim prtFont_1 As New Font("arial", 6, FontStyle.Regular)
            Dim prtPen_1 As New Pen(System.Drawing.Color.LightGray, 1)
            Dim myRectangle As RectangleF
            Dim formatLeft As New StringFormat
            Dim formatCenter As New StringFormat
            Dim formatRight As New StringFormat
            Dim colIndex As Integer = posx.Length - 1

            formatLeft.Alignment = StringAlignment.Near
            formatCenter.Alignment = StringAlignment.Center
            formatRight.Alignment = StringAlignment.Far

            formatLeft.FormatFlags = StringFormatFlags.MeasureTrailingSpaces
            formatCenter.FormatFlags = StringFormatFlags.MeasureTrailingSpaces
            formatRight.FormatFlags = StringFormatFlags.MeasureTrailingSpaces

            ' prüfen ob der Ausdruck schon gestartet wurde
            If prtstarted = False Then
                prtVerCalc1 = e.MarginBounds.Top + 70
            End If
            ' prüfen ob es sich um eine neue Seite handelt
            If prtVerCalc1 > e.MarginBounds.Y + e.MarginBounds.Height Then
                ReportData = True
                prtVerCalc1 = e.MarginBounds.Top + 50 - fntTemp.Height  '120
                Exit Function
            Else
                ReportData = False
            End If

            Dim maxLineOverColumns As Integer = 1
            For i As Integer = 0 To colIndex


                Dim w As Single = 0
                If i < colIndex Then
                    w = CSng((posx(CInt(i + 1)) - posx(CInt(i))) * 2.54) - 5
                Else
                    w = CSng(CSng(prtMargin_W) - (posx(CInt(i))) * 2.54) - 5
                End If

                Dim strLines As String()
                strLines = Split(ColData(CInt(i)), vbCrLf)
                If maxLineOverColumns < strLines.Length Then
                    maxLineOverColumns = strLines.Length
                End If
                maxHeight = prtFont_1.Height * (strLines.Length)


                myRectangle = New RectangleF(prtMargin_X1 + CSng((posx(CInt(i))) * 2.54), prtVerCalc1, w, maxHeight)


                Select Case True
                    Case Algin(CInt(i)) = Nothing
                        gr.DrawString(ColData(CInt(i)), prtFont_1, Brushes.Black, myRectangle, formatLeft)
                    Case Algin(CInt(i)) = DataAlgin.Left
                        gr.DrawString(ColData(CInt(i)), prtFont_1, Brushes.Black, myRectangle, formatLeft)
                    Case Algin(CInt(i)) = DataAlgin.Center
                        gr.DrawString(ColData(CInt(i)), prtFont_1, Brushes.Black, myRectangle, formatCenter)
                    Case Algin(CInt(i)) = DataAlgin.Right
                        gr.DrawString(ColData(CInt(i)), prtFont_1, Brushes.Black, myRectangle, formatRight)
                End Select
            Next

            maxHeight = prtFont_1.Height * maxLineOverColumns
            prtVerCalc1 += maxHeight

            gr.DrawLine(prtPen_1, prtMargin_X1, prtVerCalc1, prtMargin_X2, prtVerCalc1)
            prtVerCalc1 += 2

            fntTemp.Dispose()
            prtFont_1.Dispose()
            prtPen_1.Dispose()
        End Function


        Public Enum DataAlgin
            Left = 1
            Center = 2
            Right = 4
        End Enum

    End Class
End Namespace