﻿Imports edankTLL.edank.LGTV.Channels

Public Class frmDVBCTEdit

    Friend Channel As DVBCT_Channel

    Private Sub frmDVBCTEdit_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load


        nudNr.Value = Channel.Number
        txtName.Text = Channel.NameInFile
        txtShortName.Text = Channel.getShortName
        txtFrequency.Text = Channel.Frequency.ToString("0 Mhz")
        txtServiceID.Text = Channel.ServiceID_SID.ToString
        txtTransportStreamID.Text = Channel.TransportStreamID_TSID.ToString
        txtOriginalNetworkID.Text = Channel.OriginalNetworkID_ONID.ToString
        txtAudioPid.Text = Channel.AudioPid.ToString

        chkFavA.Checked = (Channel.FavByte And DVBCT_Channel.ChannelFavoriten.A) = DVBCT_Channel.ChannelFavoriten.A
        chkFavB.Checked = (Channel.FavByte And DVBCT_Channel.ChannelFavoriten.B) = DVBCT_Channel.ChannelFavoriten.B
        chkFavC.Checked = (Channel.FavByte And DVBCT_Channel.ChannelFavoriten.C) = DVBCT_Channel.ChannelFavoriten.C
        chkFavD.Checked = (Channel.FavByte And DVBCT_Channel.ChannelFavoriten.D) = DVBCT_Channel.ChannelFavoriten.D

        chkSkip.Checked = (Channel.SkeepLockByte And DVBCT_Channel.ChannelSkipLockMode.Skip) = DVBCT_Channel.ChannelSkipLockMode.Skip
        chkLock.Checked = (Channel.SkeepLockByte And DVBCT_Channel.ChannelSkipLockMode.Lock) = DVBCT_Channel.ChannelSkipLockMode.Lock
    End Sub

    Private Sub butSave_Click(sender As System.Object, e As System.EventArgs) Handles butSave.Click


        Dim start As Integer = txtName.Text.IndexOf(Chr(&H86), 0)
        Dim ende As Integer = txtName.Text.IndexOf(Chr(&H87), 0)

        Do While start > -1 AndAlso ende > -1

            If start > ende Then
                MessageBox.Show(My.Resources.str100, My.Resources.strInformation, MessageBoxButtons.OK, MessageBoxIcon.Information)
                Return
            End If

            If txtName.Text.Substring(start + 1, ende - start - 1).Contains(Chr(&H86)) Then
                MessageBox.Show(My.Resources.str100, My.Resources.strInformation, MessageBoxButtons.OK, MessageBoxIcon.Information)
                Return
            End If

            If txtName.Text.Substring(start + 1, ende - start - 1).Contains(Chr(&H87)) Then
                MessageBox.Show(My.Resources.str100, My.Resources.strInformation, MessageBoxButtons.OK, MessageBoxIcon.Information)
                Return
            End If

            start = txtName.Text.IndexOf(Chr(&H86), start + 1)
            ende = txtName.Text.IndexOf(Chr(&H87), ende + 1)
        Loop
        If start <> -1 OrElse ende <> -1 Then
            MessageBox.Show(My.Resources.str100, My.Resources.strInformation, MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        End If



        Channel.Number = CUShort(nudNr.Value)
        Channel.NameInFile = txtName.Text


        'Alle FavBits auf FavByte auf Null setzen
        If (Channel.FavByte And DVBCT_Channel.ChannelFavoriten.A) = DVBCT_Channel.ChannelFavoriten.A Then Channel.FavByte = Channel.FavByte Xor DVBCT_Channel.ChannelFavoriten.A
        If (Channel.FavByte And DVBCT_Channel.ChannelFavoriten.B) = DVBCT_Channel.ChannelFavoriten.B Then Channel.FavByte = Channel.FavByte Xor DVBCT_Channel.ChannelFavoriten.B
        If (Channel.FavByte And DVBCT_Channel.ChannelFavoriten.C) = DVBCT_Channel.ChannelFavoriten.C Then Channel.FavByte = Channel.FavByte Xor DVBCT_Channel.ChannelFavoriten.C
        If (Channel.FavByte And DVBCT_Channel.ChannelFavoriten.D) = DVBCT_Channel.ChannelFavoriten.D Then Channel.FavByte = Channel.FavByte Xor DVBCT_Channel.ChannelFavoriten.D

        'FavBits auf FavByte setzen
        If chkFavA.Checked Then Channel.FavByte = Channel.FavByte Or DVBCT_Channel.ChannelFavoriten.A
        If chkFavB.Checked Then Channel.FavByte = Channel.FavByte Or DVBCT_Channel.ChannelFavoriten.B
        If chkFavC.Checked Then Channel.FavByte = Channel.FavByte Or DVBCT_Channel.ChannelFavoriten.C
        If chkFavD.Checked Then Channel.FavByte = Channel.FavByte Or DVBCT_Channel.ChannelFavoriten.D

        'Alle Skip-LockBits auf SkeepLockByte auf Null setzen
        If (Channel.SkeepLockByte And DVBCT_Channel.ChannelSkipLockMode.Skip) = DVBCT_Channel.ChannelSkipLockMode.Skip Then Channel.SkeepLockByte = Channel.SkeepLockByte Xor DVBCT_Channel.ChannelSkipLockMode.Skip
        If (Channel.SkeepLockByte And DVBCT_Channel.ChannelSkipLockMode.Lock) = DVBCT_Channel.ChannelSkipLockMode.Lock Then Channel.SkeepLockByte = Channel.SkeepLockByte Xor DVBCT_Channel.ChannelSkipLockMode.Lock

        'Skip-LockBits auf SkeepLockByte setzen
        If chkSkip.Checked Then Channel.SkeepLockByte = Channel.SkeepLockByte Or DVBCT_Channel.ChannelSkipLockMode.Skip
        If chkLock.Checked Then Channel.SkeepLockByte = Channel.SkeepLockByte Or DVBCT_Channel.ChannelSkipLockMode.Lock

        Me.Close()
    End Sub

    Private Sub butInsertShortNameStart_Click(sender As System.Object, e As System.EventArgs) Handles butInsertShortNameStart.Click
        txtName.SelectedText = Chr(&H86)
        txtName.Focus()

    End Sub

    Private Sub butInsertShortNameEnd_Click(sender As System.Object, e As System.EventArgs) Handles butInsertShortNameEnd.Click
        txtName.SelectedText = Chr(&H87)
        txtName.Focus()

    End Sub

    Private Sub txtName_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtName.TextChanged
        Dim r As String = String.Empty

        Dim start As Integer = txtName.Text.IndexOf(Chr(&H86), 0)
        Dim ende As Integer = txtName.Text.IndexOf(Chr(&H87), 0)

        Do While start > -1 AndAlso ende > -1 AndAlso start < ende

            r &= txtName.Text.Substring(start + 1, ende - start - 1)

            start = txtName.Text.IndexOf(Chr(&H86), start + 1)
            ende = txtName.Text.IndexOf(Chr(&H87), ende + 1)
        Loop

        txtShortName.Text = r
    End Sub


End Class