﻿Imports edankTLL.edank
Imports edankTLL.edank.LGTV
Imports edankTLL.edank.LGTV.Channels
Imports System.Runtime.InteropServices

Public Class frmMain
    Dim gres As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(frmMain))


    Friend mytll_ReadSave As tll_ReadSave
    Private CurrentFile As String = String.Empty
    Private prtStarted As Boolean = False

    'Debug######
    Friend currentChannel As Object
    Private frmEncode As frmEncode = Nothing
    Private frmTransponderEncoding As frmTransponderEncoding = Nothing


    'Dim x As New ListViewColumnSorter
    '#######

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Me.Text &= "  Version: " & My.Application.Info.Version.ToString

        ilDVB.Images.Add("TV", My.Resources.imgTV16)
        ilDVB.Images.Add("Radio", My.Resources.imgRadio16)

        Call lvwChannels_SelectedIndexChanged(Nothing, Nothing)
        Call setControlsEnabled()

        If My.Application.CommandLineArgs.Count > 0 Then
            Call File_Open(My.Application.CommandLineArgs(0))
        End If

        'Help beim Start richtig setzen
        Call chkHelp_CheckedChanged(chkHelp, System.EventArgs.Empty)
    End Sub



#Region "Main File Operation"

#Region "Open"

    Private Sub tsmiOpen_Click(sender As System.Object, e As System.EventArgs) Handles tsmiOpen.Click, tsbOpen.Click
        'Handles tsmiOpen.Click, tsbOpen.Click
        Call File_Open()
    End Sub

    Private Sub File_Open(Optional File As String = "")
        If File <> "" Then
            If IO.File.Exists(File) Then
                If File.EndsWith(".tll", True, Globalization.CultureInfo.CurrentCulture) Then
                    CurrentFile = File
                    mytll_ReadSave = Nothing
                    Call ReadChannels()
                    Call setControlsEnabled()
                Else
                    MessageBox.Show(My.Resources.strCantOpenFileType, My.Resources.strInformation, MessageBoxButtons.OK, MessageBoxIcon.Information)
                End If
            End If
        Else
            Dim ofd As New OpenFileDialog
            ofd.Filter = My.Resources.strFileFilter

            If ofd.ShowDialog = Windows.Forms.DialogResult.OK Then
                CurrentFile = ofd.FileName
                ofd.Dispose()
                mytll_ReadSave = Nothing
                Call ReadChannels()
                Call setControlsEnabled()
            End If

        End If

    End Sub

#End Region

#Region "Save"

    Private Sub SaveFile_Click(sender As System.Object, e As System.EventArgs) Handles tsmiSave.Click, tsbSave.Click
        'Handles tsmiSave.Click, tsbSave.Click
        Call Save()
    End Sub

    Private Sub SaveAsFile_Click(sender As System.Object, e As System.EventArgs) Handles tsmiSaveAs.Click
        'Handles tsmiSaveAs.Click
        Call Save(True)
    End Sub

    Private Sub Save(Optional SaveAs As Boolean = False)
        If mytll_ReadSave Is Nothing Then Return

        Dim d As String = mytll_ReadSave.checkNumberDuppletten
        If d <> String.Empty Then
            MessageBox.Show(d, My.Resources.strInformation, MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        End If

        If SaveAs Then
            Dim sfd As New SaveFileDialog
            sfd.Filter = My.Resources.strFileFilter

            If sfd.ShowDialog = Windows.Forms.DialogResult.OK Then
                Dim SaveAsFile As String = sfd.FileName
                sfd.Dispose()
                mytll_ReadSave.SaveToFile(SaveAsFile)
                CurrentFile = SaveAsFile
                mytll_ReadSave = Nothing
                Call ReadChannels()
                Call setControlsEnabled()
            End If

        Else
            mytll_ReadSave.SaveToFile(String.Empty)
            tslblChecksum.Text = String.Format(My.Resources.strDVBSCheckSum, mytll_ReadSave.Checksum.ToString("X2"), mytll_ReadSave.ChecksumOffset.ToString("X2"))
            If mytll_ReadSave.isChecksumCalculated Then
                tslblChecksum.BackColor = Color.Green
            Else
                tslblChecksum.BackColor = Color.Red
            End If
        End If

    End Sub

#End Region

#Region "Close"

    Private Sub tsmiClose_Click(sender As System.Object, e As System.EventArgs) Handles tsmiClose.Click
        'Handles tsmiClose.Click
        CurrentFile = String.Empty
        mytll_ReadSave = Nothing
        Call ReadChannels()
        Call setControlsEnabled()
    End Sub

#End Region

#Region "Exit"

    Private Sub tsmiExit_Click(sender As System.Object, e As System.EventArgs) Handles tsmiExit.Click
        Me.Close()
    End Sub
#End Region

#End Region

#Region " Printing"

    Private Sub tsmiPrint_Click(sender As System.Object, e As System.EventArgs) Handles tsmiPrint.Click, tsbPrint.Click
        'Handles tsmiPrint.Click, tsbPrint.Click
        Dim prtDia As New PrintDialog
        prtDia.Document = prtDoc
        prtDia.AllowPrintToFile = False
        prtDia.AllowSelection = False
        prtDia.AllowSomePages = False
        prtDia.PrintToFile = False
        If prtDia.ShowDialog = Windows.Forms.DialogResult.OK Then
            prtDia.Dispose()
            prtStarted = False
            prtDoc.DefaultPageSettings.Margins.Bottom = 75
            prtDoc.DefaultPageSettings.Margins.Top = 75
            prtDoc.DefaultPageSettings.Margins.Left = 50
            prtDoc.DefaultPageSettings.Margins.Right = 50
            Dim prtPreDia As New PrintPreviewDialog
            prtPreDia.Document = prtDoc
            prtPreDia.UseAntiAlias = True
            prtPreDia.Icon = My.Resources.AppIco
            prtPreDia.WindowState = FormWindowState.Maximized
            prtPreDia.ShowDialog()
            prtPreDia.Dispose()
        End If
    End Sub

    Private Sub prtDoc_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles prtDoc.PrintPage
        Static Dim posx(5) As Integer, Titel, ColName(5), ColData(5) As String, a, myPage As Integer
        Static Dim ColAlgin(5), ColDetailAlgin(5) As Print.DataAlgin
        If prtStarted = False Then
            a = 0
            posx(0) = 0
            posx(1) = 15
            posx(2) = 100
            posx(3) = 150
            posx(4) = 200
            posx(5) = 250
            ColName(0) = My.Resources.strReportNumber
            ColName(1) = My.Resources.strReportChannel
            ColName(2) = My.Resources.strReportChannelShort
            ColName(3) = My.Resources.strReportFavorites
            ColName(4) = My.Resources.strReportSkip
            ColName(5) = My.Resources.strReportLock

            Select Case True
                Case optAnalog.Checked
                    Titel = My.Resources.strReportTitelAnalog & If(optTV.Checked, " (TV)", " (Radio)")
                Case optDVBCT.Checked
                    Titel = My.Resources.strReportTitelDVBCT & If(optTV.Checked, " (TV)", " (Radio)")
                Case optDVBS.Checked
                    Titel = My.Resources.strReportTitelDVBS & If(optTV.Checked, " (TV)", " (Radio)")
            End Select

            ColAlgin(0) = Print.DataAlgin.Right
            ColAlgin(1) = Print.DataAlgin.Left
            ColAlgin(2) = Print.DataAlgin.Left
            ColAlgin(3) = Print.DataAlgin.Center
            ColAlgin(4) = Print.DataAlgin.Center
            ColAlgin(5) = Print.DataAlgin.Center

            Call Print.ReportHeader(e, Titel)
            myPage = 0
        End If
        myPage += 1
        Call Print.PageHeader(e, posx, ColName, myPage, ColAlgin)
        For a = a To lvwChannels.Items.Count - 1

            Dim curChannel As Object = lvwChannels.Items(a).Tag

            Select Case True
                Case TypeOf curChannel Is DVBCT_Channel
                    Dim ctc As DVBCT_Channel = DirectCast(curChannel, DVBCT_Channel)
                    With ctc
                        ColData(0) = .Number.ToString
                        ColData(1) = .DisplayName
                        ColData(2) = .getShortName
                        ColData(3) = .get_strFavoriten
                        ColData(4) = .get_strSkip
                        ColData(5) = .get_strLock
                    End With

                Case TypeOf curChannel Is Analog_Channel
                    Dim ac As Analog_Channel = DirectCast(curChannel, Analog_Channel)
                    With ac
                        ColData(0) = .Number.ToString
                        ColData(1) = .DisplayName
                        ColData(2) = .getShortName
                        ColData(3) = .get_strFavoriten
                        ColData(4) = .get_strSkip
                        ColData(5) = .get_strLock
                    End With

                Case TypeOf curChannel Is DVBS_Channel
                    Dim sc As DVBS_Channel = DirectCast(curChannel, DVBS_Channel)
                    With sc
                        ColData(0) = .Number.ToString
                        ColData(1) = .DisplayName
                        ColData(2) = .getShortName
                        ColData(3) = .get_strFavoriten
                        ColData(4) = .get_strSkip
                        ColData(5) = .get_strLock
                    End With
            End Select

            ColDetailAlgin(0) = Print.DataAlgin.Right
            ColDetailAlgin(1) = Print.DataAlgin.Left
            ColDetailAlgin(2) = Print.DataAlgin.Left
            ColDetailAlgin(3) = Print.DataAlgin.Center
            ColDetailAlgin(4) = Print.DataAlgin.Center
            ColDetailAlgin(5) = Print.DataAlgin.Center


            If Print.ReportData(e, posx, ColName, ColData, ColDetailAlgin, prtStarted) = True Then
                e.HasMorePages = True
                Exit Sub
            Else
                e.HasMorePages = False
            End If
            prtStarted = True
        Next
        If a = lvwChannels.Items.Count Then
            prtStarted = False
        End If
    End Sub

#End Region


    Private Sub setControlsEnabled()
        Dim tllReadSave As Boolean = (mytll_ReadSave Is Nothing = False)
        Dim tllReadSaveItems As Boolean = (mytll_ReadSave Is Nothing = False) AndAlso lvwChannels.Items.Count <> 0 AndAlso chkDVBS_Deleted.Checked = False
        Dim tllReadSaveSelectedItems As Boolean = (mytll_ReadSave Is Nothing = False) AndAlso lvwChannels.SelectedItems.Count <> 0 AndAlso chkDVBS_Deleted.Checked = False
        Dim tllReadSaveSelectedItemsDeleted As Boolean = (mytll_ReadSave Is Nothing = False) AndAlso lvwChannels.SelectedItems.Count <> 0 AndAlso chkDVBS_Deleted.Checked = True



        tsmiSave.Enabled = tllReadSave
        tsbSave.Enabled = tllReadSave
        tsmiSaveAs.Enabled = tllReadSave
        tsmiClose.Enabled = tllReadSave
        tsmiTV_Menus.Enabled = tllReadSave
        tsmiHotelMenü.Enabled = tllReadSave

        tsmiReNumberChannels.Enabled = tllReadSaveItems
        tsbReNumberChannels.Enabled = tllReadSaveItems
        tsmiPrint.Enabled = tllReadSaveItems
        tsbPrint.Enabled = tllReadSaveItems

        tsmiEditChannel.Enabled = tllReadSaveSelectedItems
        tsmicEditChannel.Enabled = tllReadSaveSelectedItems
        tsbEditChannel.Enabled = tllReadSaveSelectedItems
        tsmiMoveChannelUp.Enabled = tllReadSaveSelectedItems
        tsmicMoveChannelUp.Enabled = tllReadSaveSelectedItems
        tsbMoveChannelUp.Enabled = tllReadSaveSelectedItems
        tsmiMoveChannelDown.Enabled = tllReadSaveSelectedItems
        tsmicMoveChannelDown.Enabled = tllReadSaveSelectedItems
        tsbMoveChannelDown.Enabled = tllReadSaveSelectedItems
        tsmiDeleteChannel.Enabled = tllReadSaveSelectedItems
        tsmicDeleteChannel.Enabled = tllReadSaveSelectedItems
        tsbDeleteChannel.Enabled = tllReadSaveSelectedItems

        tsmiRestoreChannel.Enabled = tllReadSaveSelectedItemsDeleted
        tsmicRestoreChannel.Enabled = tllReadSaveSelectedItemsDeleted
        tsbResoreChannel.Enabled = tllReadSaveSelectedItemsDeleted

    End Sub

    Private Sub ReadChannels()

        Dim lvwitem As ListViewItem = Nothing

        If mytll_ReadSave Is Nothing Then
            If CurrentFile <> String.Empty Then
                mytll_ReadSave = New tll_ReadSave(CurrentFile)
            End If
        End If


        lvwChannels.BeginUpdate()
        lvwChannels.Items.Clear()
        'lvwChannels.ListViewItemSorter = Nothing

        If mytll_ReadSave IsNot Nothing Then
            Select Case True
                Case optAnalog.Checked

                    For i As Integer = 0 To mytll_ReadSave.Analog.Count - 1
                        lvwitem = mytll_ReadSave.Analog.Item(i).getListViewItem

                        If optTV.Checked AndAlso DirectCast(lvwitem.Tag, Analog_Channel).isRadio = False Then
                            lvwChannels.Items.Add(lvwitem)
                        ElseIf optRadio.Checked AndAlso DirectCast(lvwitem.Tag, Analog_Channel).isRadio = True Then
                            lvwChannels.Items.Add(lvwitem)
                        End If

                    Next


                Case optDVBCT.Checked

                    For i As Integer = 0 To mytll_ReadSave.DVBCT.Count - 1
                        lvwitem = mytll_ReadSave.DVBCT.Item(i).getListViewItem

                        If optTV.Checked AndAlso DirectCast(lvwitem.Tag, DVBCT_Channel).isRadio = False Then
                            lvwChannels.Items.Add(lvwitem)
                        ElseIf optRadio.Checked AndAlso DirectCast(lvwitem.Tag, DVBCT_Channel).isRadio = True Then
                            lvwChannels.Items.Add(lvwitem)
                        End If

                    Next
                Case optDVBS.Checked

                    For i As Integer = 0 To mytll_ReadSave.DVBS.Count - 1

                        lvwitem = mytll_ReadSave.DVBS.Item(i).getListViewItem(, , chkDVBS_Deleted.Checked)
                        If lvwitem Is Nothing Then Continue For
                        Dim c As DVBS_Channel = DirectCast(lvwitem.Tag, DVBS_Channel)

                        Select Case True
                            Case optNoFilter.Checked

                                Dim t As Transponder = mytll_ReadSave.getTransponderById(c.TransponderID)
                                Dim s As Satelitte = mytll_ReadSave.getSatelitteByIndex(t.SatelitteID)
                                lvwitem.SubItems.Add(t.Frequence.ToString)
                                lvwitem.SubItems.Add(s.Name & " " & s.Position)

                                If optTV.Checked AndAlso c.isRadio = False Then
                                    lvwChannels.Items.Add(lvwitem)
                                ElseIf optRadio.Checked AndAlso c.isRadio = True Then
                                    lvwChannels.Items.Add(lvwitem)
                                End If

                            Case optByteFilter.Checked

                                If mytll_ReadSave.DVBS.Item(i).DataBlock(CInt(nudByteOffset.Value)) = nudByteValue.Value Then
                                    If optTV.Checked AndAlso c.isRadio = False Then
                                        lvwChannels.Items.Add(lvwitem)
                                    ElseIf optRadio.Checked AndAlso c.isRadio = True Then
                                        lvwChannels.Items.Add(lvwitem)
                                    End If
                                End If
                            Case optBitFilter.Checked

                                Dim b As Byte = Convert.ToByte(txtBitFilter.Text, 2)

                                If (mytll_ReadSave.DVBS.Item(i).DataBlock(CInt(nudByteOffset.Value)) And Convert.ToByte(txtBitFilter.Text, 2)) = Convert.ToByte(txtBitFilter.Text, 2) Then
                                    If optTV.Checked AndAlso c.isRadio = False Then
                                        lvwChannels.Items.Add(lvwitem)
                                    ElseIf optRadio.Checked AndAlso c.isRadio = True Then
                                        lvwChannels.Items.Add(lvwitem)
                                    End If
                                End If
                        End Select


                    Next

            End Select

            Call setTunerCounts()


            tslblLoadedFile.Text = New IO.FileInfo(CurrentFile).Name
            tslblChecksum.Text = String.Format(My.Resources.strDVBSCheckSum, mytll_ReadSave.Checksum.ToString("X2"), mytll_ReadSave.ChecksumOffset.ToString("X2"))

            If mytll_ReadSave.isChecksumCalculated Then
                tslblChecksum.BackColor = Color.Green
            Else
                tslblChecksum.BackColor = Color.Red
            End If
        Else

            optAnalog.Text = gres.GetString("optAnalog.Text")
            optDVBCT.Text = gres.GetString("optDVBCT.Text")
            optDVBS.Text = gres.GetString("optDVBS.Text")

            optTV.Text = gres.GetString("optTV.Text")
            optRadio.Text = gres.GetString("optRadio.Text")

            tslblLoadedFile.Text = gres.GetString("tslblLoadedFile.Text")
            tslblChecksum.Text = gres.GetString("tslblChecksum.Text")


        End If

        lvwChannels.EndUpdate()
        Call lvwChannels_SelectedIndexChanged(Nothing, Nothing)

    End Sub

    Private Sub setTunerCounts()
        optAnalog.Text = String.Format("{0} ({1})", gres.GetString("optAnalog.Text"), mytll_ReadSave.Analog.Count.ToString)
        optDVBCT.Text = String.Format("{0} ({1})", gres.GetString("optDVBCT.Text"), mytll_ReadSave.DVBCT.Count.ToString)
        optDVBS.Text = String.Format("{0} ({1})", gres.GetString("optDVBS.Text"), mytll_ReadSave.getDVBSChannelCount.ToString)

        Select Case True
            Case optAnalog.Checked
                optTV.Text = String.Format("{0} ({1})", gres.GetString("optTV.Text"), mytll_ReadSave.getChannelCount(tll_ReadSave.ChannelType.Analog, False).ToString)
                optRadio.Text = String.Format("{0} ({1})", gres.GetString("optRadio.Text"), mytll_ReadSave.getChannelCount(tll_ReadSave.ChannelType.Analog, True).ToString)
            Case optDVBCT.Checked
                optTV.Text = String.Format("{0} ({1})", gres.GetString("optTV.Text"), mytll_ReadSave.getChannelCount(tll_ReadSave.ChannelType.DVBCT, False).ToString)
                optRadio.Text = String.Format("{0} ({1})", gres.GetString("optRadio.Text"), mytll_ReadSave.getChannelCount(tll_ReadSave.ChannelType.DVBCT, True).ToString)
            Case optDVBS.Checked
                optTV.Text = String.Format("{0} ({1})", gres.GetString("optTV.Text"), mytll_ReadSave.getChannelCount(tll_ReadSave.ChannelType.DVBS, False).ToString)
                optRadio.Text = String.Format("{0} ({1})", gres.GetString("optRadio.Text"), mytll_ReadSave.getChannelCount(tll_ReadSave.ChannelType.DVBS, True).ToString)
        End Select
    End Sub


    'Private Sub lvwChannels_ColumnClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ColumnClickEventArgs) Handles lvwChannels.ColumnClick
    '    If optDVBCT.Checked OrElse lvwChannels.Items.Count < 2 Then Return

    '    Select Case e.Column
    '        Case 1, 7, 8, 9, 10
    '            x.isDateColumn = False
    '            x.isNumericColumn = True
    '        Case 2, 3, 4, 5, 6, 11
    '            x.isDateColumn = False
    '            x.isNumericColumn = False
    '    End Select

    '    If e.Column = x.SortColumn Then
    '        If x.Order = SortOrder.Ascending Then
    '            x.Order = SortOrder.Descending
    '        Else
    '            x.Order = SortOrder.Ascending
    '        End If
    '    Else
    '        x.SortColumn = e.Column
    '        x.Order = SortOrder.Ascending
    '    End If
    '    lvwChannels.Sort()
    'End Sub

    Private Sub lvwChannels_DoubleClick(sender As Object, e As System.EventArgs) Handles lvwChannels.DoubleClick
        Call EditChannel(Nothing, Nothing)
    End Sub

    Private Sub lvwChannels_DragDrop(sender As Object, e As System.Windows.Forms.DragEventArgs) Handles lvwChannels.DragDrop
        Call File_Open(CType(e.Data.GetData(DataFormats.FileDrop), Array).GetValue(0).ToString)
    End Sub

    Private Sub lvwChannels_DragEnter(sender As Object, e As System.Windows.Forms.DragEventArgs) Handles lvwChannels.DragEnter
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            e.Effect = DragDropEffects.Copy
        End If
    End Sub

    Private Sub lvwChannels_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles lvwChannels.SelectedIndexChanged
        Call PrintDebugData()
        Call setControlsEnabled()

        'Debug##########
        If lvwChannels.SelectedItems.Count <> 0 Then
            currentChannel = lvwChannels.SelectedItems(0).Tag
        Else
            currentChannel = Nothing
        End If
        If frmEncode IsNot Nothing Then
            frmEncode.nudByteOffset_ValueChanged(Nothing, Nothing)
        End If
        '###################
    End Sub

    Private Sub frmMain_KeyDown(sender As Object, e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        If lvwChannels.Items.Count = 0 Then Return
        If e.Modifiers <> 0 Then Return

        Dim str As String = Keybord.getStringFromKeybord(e.KeyData)
        If str = String.Empty Then Return

        Dim idx As Integer = 0
        If lvwChannels.SelectedItems.Count <> 0 Then
            idx = lvwChannels.SelectedItems(0).Index
            If idx < lvwChannels.Items.Count - 1 Then
                idx += 1
            Else
                idx = 0
            End If
        End If

        For i As Integer = idx To lvwChannels.Items.Count - 1
            If lvwChannels.Items(i).SubItems(2).Text.ToUpper.StartsWith(str) Then
                lvwChannels.MultiSelect = False
                lvwChannels.Items(i).Selected = True
                lvwChannels.EnsureVisible(i)
                lvwChannels.MultiSelect = True
                lvwChannels.Focus()
                Return
            End If
        Next

        If idx > 0 Then
            For i As Integer = 0 To idx
                If lvwChannels.Items(i).SubItems(2).Text.ToUpper.StartsWith(str) Then
                    lvwChannels.MultiSelect = False
                    lvwChannels.Items(i).Selected = True
                    lvwChannels.EnsureVisible(i)
                    lvwChannels.MultiSelect = True
                    lvwChannels.Focus()
                    Return
                End If
            Next
        End If

    End Sub


    Private Sub optDVBCT_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles optAnalog.CheckedChanged, optDVBCT.CheckedChanged, optDVBS.CheckedChanged, chkDVBS_Deleted.CheckedChanged
        'Handles optAnalog.CheckedChanged, optDVBCT.CheckedChanged, optDVBS.CheckedChanged
        If TypeOf sender Is RadioButton AndAlso DirectCast(sender, RadioButton).Checked = False Then Return
        chkDVBS_Deleted.Checked = If(optDVBS.Checked, chkDVBS_Deleted.Checked, False)
        chkDVBS_Deleted.Enabled = optDVBS.Checked
        Call ReadChannels()
        Call setControlsEnabled()
    End Sub

    Private Sub optTV_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles optTV.CheckedChanged, optRadio.CheckedChanged
        'Handles optTV.CheckedChanged, optRadio.CheckedChanged
        If DirectCast(sender, RadioButton).Checked = False Then Return
        Call ReadChannels()
    End Sub

#Region "Channel Operation"

#Region "Edit Channel"

    Private Sub EditChannel(sender As System.Object, e As System.EventArgs) Handles tsmiEditChannel.Click, tsmicEditChannel.Click, tsbEditChannel.Click
        'Handles tsmiEditChannel.Click, tsmicEditChannel.Click, tsbEditChannel.Click

        If chkDVBS_Deleted.Checked Then Return

        If lvwChannels.SelectedItems.Count = 0 Then Return

        Select Case True
            Case TypeOf lvwChannels.SelectedItems(0).Tag Is Analog_Channel

                If lvwChannels.SelectedItems.Count = 1 Then

                    Dim c_Channel As Analog_Channel = DirectCast(lvwChannels.SelectedItems(0).Tag, Analog_Channel)
                    Dim OldNumber As UInt16 = c_Channel.Number


                    Dim frmDVBCTEdit As New frmDVBCTEdit
                    frmDVBCTEdit.Channel = c_Channel
                    frmDVBCTEdit.ShowDialog()
                    frmDVBCTEdit.Dispose()

                    If c_Channel.Number <> OldNumber Then
                        mytll_ReadSave.sortChannel(tll_ReadSave.ChannelType.Analog)
                        Call ReadChannels()
                    Else
                        c_Channel.reloadListViewItem(lvwChannels.SelectedItems(0))
                    End If

                Else

                    Dim ChannelCount As Integer = lvwChannels.SelectedItems.Count - 1
                    Dim c_Channel(ChannelCount) As Analog_Channel

                    For i As Integer = 0 To ChannelCount
                        c_Channel(i) = DirectCast(lvwChannels.SelectedItems(i).Tag, Analog_Channel)
                    Next

                    Dim frmDVBCTMultiEdit As New frmChannelMultiEdit
                    frmDVBCTMultiEdit.Channel = c_Channel
                    frmDVBCTMultiEdit.ShowDialog()
                    frmDVBCTMultiEdit.Dispose()

                    For i As Integer = 0 To ChannelCount
                        c_Channel(i).reloadListViewItem(lvwChannels.SelectedItems(i))
                    Next

                End If

            Case TypeOf lvwChannels.SelectedItems(0).Tag Is DVBCT_Channel

                If lvwChannels.SelectedItems.Count = 1 Then

                    Dim c_Channel As DVBCT_Channel = DirectCast(lvwChannels.SelectedItems(0).Tag, DVBCT_Channel)
                    Dim OldNumber As UInt16 = c_Channel.Number


                    Dim frmDVBCTEdit As New frmDVBCTEdit
                    frmDVBCTEdit.Channel = c_Channel
                    frmDVBCTEdit.ShowDialog()
                    frmDVBCTEdit.Dispose()

                    If c_Channel.Number <> OldNumber Then
                        mytll_ReadSave.sortChannel(tll_ReadSave.ChannelType.DVBCT)
                        Call ReadChannels()
                    Else
                        c_Channel.reloadListViewItem(lvwChannels.SelectedItems(0))
                    End If

                Else
                    Dim ChannelCount As Integer = lvwChannels.SelectedItems.Count - 1
                    Dim c_Channel(ChannelCount) As DVBCT_Channel

                    For i As Integer = 0 To ChannelCount
                        c_Channel(i) = DirectCast(lvwChannels.SelectedItems(i).Tag, DVBCT_Channel)
                    Next

                    Dim frmDVBCTMultiEdit As New frmChannelMultiEdit
                    frmDVBCTMultiEdit.Channel = c_Channel
                    frmDVBCTMultiEdit.ShowDialog()
                    frmDVBCTMultiEdit.Dispose()

                    For i As Integer = 0 To ChannelCount
                        c_Channel(i).reloadListViewItem(lvwChannels.SelectedItems(i))
                    Next

                End If

            Case TypeOf lvwChannels.SelectedItems(0).Tag Is DVBS_Channel

                If lvwChannels.SelectedItems.Count = 1 Then

                    Dim c_Channel As DVBS_Channel = DirectCast(lvwChannels.SelectedItems(0).Tag, DVBS_Channel)
                    Dim OldNumber As UInt16 = c_Channel.Number

                    Dim frmDVBSEdit As New frmDVBSEdit
                    frmDVBSEdit.Channel = c_Channel
                    frmDVBSEdit.ShowDialog()
                    frmDVBSEdit.Dispose()

                    If c_Channel.Number <> OldNumber Then
                        mytll_ReadSave.sortChannel(tll_ReadSave.ChannelType.DVBS)
                        Call ReadChannels()
                    Else
                        c_Channel.reloadListViewItem(lvwChannels.SelectedItems(0))
                    End If

                Else
                    Dim ChannelCount As Integer = lvwChannels.SelectedItems.Count - 1
                    Dim c_Channel(ChannelCount) As DVBS_Channel

                    For i As Integer = 0 To ChannelCount
                        c_Channel(i) = DirectCast(lvwChannels.SelectedItems(i).Tag, DVBS_Channel)
                    Next

                    Dim frmChannelMultiEdit As New frmChannelMultiEdit
                    frmChannelMultiEdit.Channel = c_Channel
                    frmChannelMultiEdit.ShowDialog()
                    frmChannelMultiEdit.Dispose()

                    For i As Integer = 0 To ChannelCount
                        c_Channel(i).reloadListViewItem(lvwChannels.SelectedItems(i))
                    Next

                End If

        End Select

        Call PrintDebugData()

    End Sub

#End Region

#Region "Move Channel"

    Private Sub MoveChannelUp(sender As System.Object, e As System.EventArgs) Handles tsmiMoveChannelUp.Click, tsmicMoveChannelUp.Click, tsbMoveChannelUp.Click
        'Handles tsmiMoveChannelUp.Click, tsmicMoveChannelUp.Click, tsbMoveChannelUp.Click
        Call moveChannel(True)
    End Sub

    Private Sub MoveChannelDown(sender As System.Object, e As System.EventArgs) Handles tsmiMoveChannelDown.Click, tsmicMoveChannelDown.Click, tsbMoveChannelDown.Click
        'Handles tsmiMoveChannelDown.Click, tsmicMoveChannelDown.Click, tsbMoveChannelDown.Click
        Call moveChannel(False)
    End Sub

    Private Sub moveChannel(boolUp As Boolean)
        'If TypeOf lvwChannels.SelectedItems(0).Tag Is DVBS_Channel Then Return
        ' If TypeOf lvwChannels.SelectedItems(0).Tag Is DVBS_Channel Then Return


        If lvwChannels.SelectedItems.Count = 0 Then Return

        If boolUp = True Then
            If lvwChannels.SelectedItems(0).Index = 0 Then Return
        Else
            If lvwChannels.SelectedItems(lvwChannels.SelectedItems.Count - 1).Index = lvwChannels.Items.Count - 1 Then Return
        End If

        lvwChannels.BeginUpdate()

        Select Case True
            Case TypeOf lvwChannels.SelectedItems(0).Tag Is Analog_Channel

                For i As Integer = 0 To lvwChannels.SelectedItems.Count - 1

                    Dim CurrentlvwItem As ListViewItem = lvwChannels.SelectedItems(If(boolUp, i, lvwChannels.SelectedItems.Count - i - 1))
                    Dim currentIndex As Integer = CurrentlvwItem.Index
                    Dim CurrentChannel As Analog_Channel = DirectCast(CurrentlvwItem.Tag, Analog_Channel)
                    Dim CurrentChannelIndex As Integer = mytll_ReadSave.Analog.IndexOf(CurrentChannel)
                    Dim CurrentNumber As UInt16 = CurrentChannel.Number

                    Dim newIndex As Integer = If(boolUp, currentIndex - 1, currentIndex + 1)
                    Dim newLvwItem As ListViewItem = lvwChannels.Items(newIndex)
                    Dim NewChannel As Analog_Channel = (DirectCast(newLvwItem.Tag, Analog_Channel))
                    Dim NewChannelIndex As Integer = mytll_ReadSave.Analog.IndexOf(NewChannel)
                    Dim newNumber As UInt16 = NewChannel.Number

                    CurrentChannel.Number = newNumber
                    NewChannel.Number = CurrentNumber

                    mytll_ReadSave.Analog.Remove(CurrentChannel)
                    mytll_ReadSave.Analog.Insert(NewChannelIndex, CurrentChannel)

                    lvwChannels.Items.Remove(CurrentlvwItem)
                    lvwChannels.Items.Insert(newIndex, CurrentlvwItem)

                    lvwChannels.Items(newIndex).Selected = True
                    lvwChannels.EnsureVisible(newIndex)

                    CurrentChannel.reloadListViewItem(CurrentlvwItem)
                    NewChannel.reloadListViewItem(newLvwItem)

                Next

            Case TypeOf lvwChannels.SelectedItems(0).Tag Is DVBCT_Channel

                For i As Integer = 0 To lvwChannels.SelectedItems.Count - 1

                    Dim CurrentlvwItem As ListViewItem = lvwChannels.SelectedItems(If(boolUp, i, lvwChannels.SelectedItems.Count - i - 1))
                    Dim currentIndex As Integer = CurrentlvwItem.Index
                    Dim CurrentChannel As DVBCT_Channel = DirectCast(CurrentlvwItem.Tag, DVBCT_Channel)
                    Dim CurrentChannelIndex As Integer = mytll_ReadSave.DVBCT.IndexOf(CurrentChannel)
                    Dim CurrentNumber As UInt16 = CurrentChannel.Number

                    Dim newIndex As Integer = If(boolUp, currentIndex - 1, currentIndex + 1)
                    Dim newLvwItem As ListViewItem = lvwChannels.Items(newIndex)
                    Dim NewChannel As DVBCT_Channel = (DirectCast(newLvwItem.Tag, DVBCT_Channel))
                    Dim NewChannelIndex As Integer = mytll_ReadSave.DVBCT.IndexOf(NewChannel)
                    Dim newNumber As UInt16 = NewChannel.Number

                    CurrentChannel.Number = newNumber
                    NewChannel.Number = CurrentNumber

                    mytll_ReadSave.DVBCT.Remove(CurrentChannel)
                    mytll_ReadSave.DVBCT.Insert(NewChannelIndex, CurrentChannel)

                    lvwChannels.Items.Remove(CurrentlvwItem)
                    lvwChannels.Items.Insert(newIndex, CurrentlvwItem)

                    lvwChannels.Items(newIndex).Selected = True
                    lvwChannels.EnsureVisible(newIndex)

                    CurrentChannel.reloadListViewItem(CurrentlvwItem)
                    NewChannel.reloadListViewItem(newLvwItem)

                Next

            Case TypeOf lvwChannels.SelectedItems(0).Tag Is DVBS_Channel



                For i As Integer = 0 To lvwChannels.SelectedItems.Count - 1

                    Dim CurrentlvwItem As ListViewItem = lvwChannels.SelectedItems(If(boolUp, i, lvwChannels.SelectedItems.Count - i - 1))
                    Dim currentIndex As Integer = CurrentlvwItem.Index
                    Dim CurrentChannel As DVBS_Channel = DirectCast(CurrentlvwItem.Tag, DVBS_Channel)
                    Dim CurrentChannelIndex As Integer = mytll_ReadSave.DVBS.IndexOf(CurrentChannel)
                    Dim CurrentNumber As UInt16 = CurrentChannel.Number

                    Dim newIndex As Integer = If(boolUp, currentIndex - 1, currentIndex + 1)
                    Dim newLvwItem As ListViewItem = lvwChannels.Items(newIndex)
                    Dim NewChannel As DVBS_Channel = (DirectCast(newLvwItem.Tag, DVBS_Channel))
                    Dim NewChannelIndex As Integer = mytll_ReadSave.DVBS.IndexOf(NewChannel)
                    Dim newNumber As UInt16 = NewChannel.Number

                    CurrentChannel.Number = newNumber
                    NewChannel.Number = CurrentNumber

                    mytll_ReadSave.DVBS.Remove(CurrentChannel)
                    mytll_ReadSave.DVBS.Insert(NewChannelIndex, CurrentChannel)

                    lvwChannels.Items.Remove(CurrentlvwItem)
                    lvwChannels.Items.Insert(newIndex, CurrentlvwItem)

                    lvwChannels.Items(newIndex).Selected = True
                    lvwChannels.EnsureVisible(newIndex)

                    CurrentChannel.reloadListViewItem(CurrentlvwItem)
                    NewChannel.reloadListViewItem(newLvwItem)
                Next


        End Select

        lvwChannels.EndUpdate()

    End Sub

#End Region

#Region "Delete Channel"

    Private Sub DeleteChannel(sender As System.Object, e As System.EventArgs) Handles tsmiDeleteChannel.Click, tsmicDeleteChannel.Click, tsbDeleteChannel.Click
        'Handles tsmiEditChannel.Click, tsmicEditChannel.Click, tsbEditChannel.Click

        If lvwChannels.SelectedItems.Count = 0 Then Return
        'If TypeOf lvwChannels.SelectedItems(0).Tag Is DVBS_Channel Then Return

        Select Case True
            Case TypeOf lvwChannels.SelectedItems(0).Tag Is Analog_Channel

                Dim c_Channel As Analog_Channel
                Dim currentlvwItem As ListViewItem
                Dim currentIndex As Integer

                For i As Integer = 0 To lvwChannels.SelectedItems.Count - 1
                    c_Channel = DirectCast(lvwChannels.SelectedItems(0).Tag, Analog_Channel)
                    currentlvwItem = lvwChannels.SelectedItems(0)
                    currentIndex = currentlvwItem.Index

                    mytll_ReadSave.DeleteChannel(c_Channel, tll_ReadSave.ChannelType.Analog)
                    lvwChannels.Items.Remove(currentlvwItem)
                Next

                If lvwChannels.Items.Count > 0 Then
                    lvwChannels.Items(If(lvwChannels.Items.Count - 1 >= currentIndex, currentIndex, currentIndex - 1)).Selected = True
                End If

            Case TypeOf lvwChannels.SelectedItems(0).Tag Is DVBCT_Channel

                Dim c_Channel As DVBCT_Channel
                Dim currentlvwItem As ListViewItem
                Dim currentIndex As Integer

                For i As Integer = 0 To lvwChannels.SelectedItems.Count - 1
                    c_Channel = DirectCast(lvwChannels.SelectedItems(0).Tag, DVBCT_Channel)
                    currentlvwItem = lvwChannels.SelectedItems(0)
                    currentIndex = currentlvwItem.Index

                    mytll_ReadSave.DeleteChannel(c_Channel, tll_ReadSave.ChannelType.DVBCT)
                    lvwChannels.Items.Remove(currentlvwItem)
                Next

                If lvwChannels.Items.Count > 0 Then
                    lvwChannels.Items(If(lvwChannels.Items.Count - 1 >= currentIndex, currentIndex, currentIndex - 1)).Selected = True
                End If

            Case TypeOf lvwChannels.SelectedItems(0).Tag Is DVBS_Channel

                Dim c_Channel As DVBS_Channel
                Dim currentlvwItem As ListViewItem
                Dim currentIndex As Integer

                For i As Integer = 0 To lvwChannels.SelectedItems.Count - 1
                    c_Channel = DirectCast(lvwChannels.SelectedItems(0).Tag, DVBS_Channel)
                    currentlvwItem = lvwChannels.SelectedItems(0)
                    currentIndex = currentlvwItem.Index

                    mytll_ReadSave.DeleteChannel(c_Channel, tll_ReadSave.ChannelType.DVBS)
                    lvwChannels.Items.Remove(currentlvwItem)
                Next

                If lvwChannels.Items.Count > 0 Then
                    lvwChannels.Items(If(lvwChannels.Items.Count - 1 >= currentIndex, currentIndex, currentIndex - 1)).Selected = True
                End If

        End Select
        Call setTunerCounts()
    End Sub

#End Region

#Region "Restore Channel DVB-S"

    Private Sub tsbResoreChannel_Click(sender As System.Object, e As System.EventArgs) Handles tsmiRestoreChannel.Click, tsmicRestoreChannel.Click, tsbResoreChannel.Click
        'Handles tsmiRestoreChannel.Click, tsmicRestoreChannel.Click, tsbResoreChannel.Click
        If lvwChannels.SelectedItems.Count = 0 Then Return

        Dim c_Channel As DVBS_Channel
        Dim currentlvwItem As ListViewItem
        Dim currentIndex As Integer

        For i As Integer = 0 To lvwChannels.SelectedItems.Count - 1
            c_Channel = DirectCast(lvwChannels.SelectedItems(0).Tag, DVBS_Channel)
            currentlvwItem = lvwChannels.SelectedItems(0)
            currentIndex = currentlvwItem.Index

            If (c_Channel.SkeepLockByte And DVBS_Channel.ChannelSkipLockMode.InVisible) = DVBS_Channel.ChannelSkipLockMode.InVisible Then
                c_Channel.SkeepLockByte = c_Channel.SkeepLockByte Xor DVBS_Channel.ChannelSkipLockMode.InVisible
                c_Channel.isInvisibleChannel = False
                lvwChannels.Items.Remove(currentlvwItem)
            Else
                currentlvwItem.Selected = False
            End If

        Next

        'If lvwChannels.Items.Count > 0 Then
        '    lvwChannels.Items(If(lvwChannels.Items.Count - 1 >= currentIndex, currentIndex, currentIndex - 1)).Selected = True
        'End If


        Call setTunerCounts()

    End Sub

#End Region

#Region "ReNumber Channels"

    Private Sub ReNumberChannels(sender As System.Object, e As System.EventArgs) Handles tsmiReNumberChannels.Click, tsbReNumberChannels.Click
        'If TypeOf lvwChannels.SelectedItems(0).Tag Is DVBS_Channel Then Return
        Dim frmRenumber As New frmRenumber With {.mytll_ReadSave = mytll_ReadSave, .o = Me}


        'Select Case True
        '    Case optAnalog.Checked
        '        mytll_ReadSave.reNumberChannels(optRadio.Checked, tll_ReadSave.ChannelType.Analog)
        '    Case optDVBCT.Checked
        '        mytll_ReadSave.reNumberChannels(optRadio.Checked, tll_ReadSave.ChannelType.DVBCT)
        '    Case optDVBS.Checked
        '        mytll_ReadSave.reNumberChannels(optRadio.Checked, tll_ReadSave.ChannelType.DVBS)
        '        mytll_ReadSave.sortChannel(tll_ReadSave.ChannelType.DVBS)
        'End Select
        frmRenumber.ShowDialog()
        frmRenumber.Dispose()

        Call ReadChannels()

    End Sub

#End Region

#End Region

    Private Sub tsmiHotelMenü_Click(sender As System.Object, e As System.EventArgs) Handles tsmiHotelMenü.Click
        If mytll_ReadSave Is Nothing Then Return
        Dim frmHotelMenu As New frmHotelMenu
        frmHotelMenu.ShowDialog(Me)
        frmHotelMenu.Dispose()
    End Sub



    'Debug soll alles wieder weg, wenn alles bekannt ist!!!##########################################################################################################

    Private Sub PrintDebugData()
        If chkHelp.Checked = False Then Return

        Dim f As New Font("Consolas", 7, FontStyle.Bold)
        Dim f2 As New Font("Consolas", 8, FontStyle.Bold)
        Dim f3 As New Font("Consolas", 8, FontStyle.Bold Or FontStyle.Underline)

        rtbChannelInfo.Clear()

        If lvwChannels.SelectedItems.Count = 0 Then Return

        Select Case True
            Case TypeOf lvwChannels.SelectedItems(0).Tag Is DVBCT_Channel OrElse TypeOf lvwChannels.SelectedItems(0).Tag Is Analog_Channel
                Dim c_Channel As DVBCT_Channel = DirectCast(lvwChannels.SelectedItems(0).Tag, DVBCT_Channel)

                Dim DecScale As String = Nothing
                For i As Integer = 0 To tll_ReadSave.DVBCT_ChannelLenght - 1
                    DecScale &= i.ToString("X2") & " "
                Next
                DecScale = DecScale.TrimEnd

                rtbChannelInfo.SelectionFont = f
                rtbChannelInfo.SelectionColor = Color.Blue
                rtbChannelInfo.SelectedText = DecScale.TrimEnd & vbCrLf


                Dim str As String = c_Channel.getBlockData
                Dim Start As Integer = rtbChannelInfo.Text.Length 'Cursor-Position merken

                rtbChannelInfo.SelectionFont = f
                rtbChannelInfo.SelectionStart = Start 'Cursor Position ans Ende des Textes 
                rtbChannelInfo.SelectionLength = 0 'Nichts markieren
                rtbChannelInfo.SelectedText = str


                'ChannelNumber
                rtbChannelInfo.SelectionStart = Start + 3 * &HC
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green

                'ChannelNumber2
                rtbChannelInfo.SelectionStart = Start + 3 * &H7C
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green

                'Favoriten
                rtbChannelInfo.SelectionStart = Start + 3 * &H14
                rtbChannelInfo.SelectionLength = 3 * 1
                rtbChannelInfo.SelectionColor = Color.Red

                'Favoriten2
                rtbChannelInfo.SelectionStart = Start + 3 * &H82
                rtbChannelInfo.SelectionLength = 3 * 1
                rtbChannelInfo.SelectionColor = Color.Red

                'ChannelName
                rtbChannelInfo.SelectionStart = Start + 3 * &H1E
                rtbChannelInfo.SelectionLength = 3 * 40
                rtbChannelInfo.SelectionColor = Color.Green

                'ChannelName2
                rtbChannelInfo.SelectionStart = Start + 3 * &H88
                rtbChannelInfo.SelectionLength = 3 * 40
                rtbChannelInfo.SelectionColor = Color.Green

                'ChannelNameLenght
                rtbChannelInfo.SelectionStart = Start + 3 * &H46
                rtbChannelInfo.SelectionLength = 3 * 1
                rtbChannelInfo.SelectionColor = Color.Green

                'ChannelNameLenght2
                rtbChannelInfo.SelectionStart = Start + 3 * &H87
                rtbChannelInfo.SelectionLength = 3 * 1
                rtbChannelInfo.SelectionColor = Color.Green

                'Frequency
                rtbChannelInfo.SelectionStart = Start + 3 * &H5C
                rtbChannelInfo.SelectionLength = 3 * 4
                rtbChannelInfo.SelectionColor = Color.Green

                'Überspringen Sperren
                rtbChannelInfo.SelectionStart = Start + 3 * &H83
                rtbChannelInfo.SelectionLength = 3 * 1
                rtbChannelInfo.SelectionColor = Color.Red

                'TransponderChannel
                rtbChannelInfo.SelectionStart = Start + 3 * &HA
                rtbChannelInfo.SelectionLength = 3 * 1
                rtbChannelInfo.SelectionColor = Color.Green

                'TransponderChannel2
                rtbChannelInfo.SelectionStart = Start + 3 * &H5A
                rtbChannelInfo.SelectionLength = 3 * 1
                rtbChannelInfo.SelectionColor = Color.Green

                'TransponderChannel3
                rtbChannelInfo.SelectionStart = Start + 3 * &H79
                rtbChannelInfo.SelectionLength = 3 * 1
                rtbChannelInfo.SelectionColor = Color.Green

                'TransponderChannel4
                rtbChannelInfo.SelectionStart = Start + 3 * &H80
                rtbChannelInfo.SelectionLength = 3 * 1
                rtbChannelInfo.SelectionColor = Color.Green

                'ServiceID
                rtbChannelInfo.SelectionStart = Start + 3 * &H48
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green

                'ServiceID2
                rtbChannelInfo.SelectionStart = Start + 3 * &H84
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green

                'OriginalNetworkID
                rtbChannelInfo.SelectionStart = Start + 3 * &H62
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green

                'TransportStreamID
                rtbChannelInfo.SelectionStart = Start + 3 * &H64
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green

                'AudioPid
                rtbChannelInfo.SelectionStart = Start + 3 * &H18
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green

                'AudioPid2
                rtbChannelInfo.SelectionStart = Start + 3 * &HB2
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green



                rtbChannelInfo.SelectionLength = 0                     'Nichts markieren
                rtbChannelInfo.SelectionStart = Start + str.Length    'Cursor ans Ende

                'SaveData
                rtbChannelInfo.SelectionFont = f
                rtbChannelInfo.SelectionColor = Color.BlueViolet
                rtbChannelInfo.SelectedText = vbCrLf & c_Channel.getBlockDatatoSave & vbCrLf & vbCrLf


                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Blue
                rtbChannelInfo.SelectedText = "Blau = Offset in Hex     "

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = "Schwarz = noch nicht entschlüsselt     "

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Red
                rtbChannelInfo.SelectedText = "Rot = teilweise entschlüsselt     "

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Green
                rtbChannelInfo.SelectedText = "Grün = ist entschlüsselt     "

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.BlueViolet
                rtbChannelInfo.SelectedText = "Violett = Veränderter Block zum Speichern"



                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = vbCrLf & vbCrLf & "Byte 0C-0D und auf 7C-7D   (2x? Warum?)  = Kanalnummer wenn > 16384 (h4000 bzw h40 im HighByte) dann minus h4000 und es ist die Radio Kanalnummer"

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = vbCrLf & "Byte 14 und auf 82         (2x? Warum?)  = Favoriten (ABCD) Byte14 0000DCBA Byte 82 00DCBA00 Bits mit 0 sind noch nicht entschlüsselt"

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = vbCrLf & "Byte 1E-45 und auf 88-AF   (2x? Warum?)  = Kanal Name"

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = vbCrLf & "Byte 46 und auf 87         (2x? Warum?)  = Kanal Name Länge"

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = vbCrLf & "Byte 5C-5F                               = Frequenz"

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = vbCrLf & "Byte 83                                  = überspringen und sperren (ÜS)   0000S0ÜS   Bits mit 0 sind noch nicht entschlüsselt"

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = vbCrLf & "Byte 0A und auf 5A, 79, 80 (4x? Warum?)  = Transponder Kanal umwandlung in K01 K02.. S01 S02... fehlt noch http://de.wikipedia.org/wiki/Kabelfernsehen"

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = vbCrLf & "Byte 48-49 und auf 84-85   (2x? Warum?)  = Service ID SID"

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = vbCrLf & "Byte 62-63                               = Original Network ID ONID"

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = vbCrLf & "Byte 64-65                               = Transport Stream ID TSID"

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = vbCrLf & "Byte 18-19 und auf B2-B3   (2x? Warum?)  = Audio Pid"



            Case TypeOf lvwChannels.SelectedItems(0).Tag Is DVBS_Channel
                Dim c_Channel As DVBS_Channel = DirectCast(lvwChannels.SelectedItems(0).Tag, DVBS_Channel)
                Dim t As Transponder = mytll_ReadSave.getTransponderById(c_Channel.TransponderID)
                Dim s As Satelitte = mytll_ReadSave.getSatelitteByIndex(t.SatelitteID)
                Dim l As LNB = mytll_ReadSave.getLNB_ByIndex(t.SatelitteID)


                Dim TitelLenght As Integer = 12
                Dim Scala As String = "Scala"
                Dim Channel As String = "Channel"
                Dim SaveChannel As String = "Save Data"
                Dim Transponder As String = "Transponder"
                Dim Satelitte As String = "Satelitte"
                Dim LNB As String = "LNB"

                Dim DecScale As String = Nothing
                For i As Integer = 0 To tll_ReadSave.DVBS_ChannelLenght - 1
                    DecScale &= i.ToString("X2") & " "
                Next
                DecScale = DecScale.TrimEnd

                rtbChannelInfo.SelectionFont = f
                rtbChannelInfo.SelectionColor = Color.Blue
                rtbChannelInfo.SelectedText = Scala & Space(TitelLenght - Scala.Length) & DecScale.TrimEnd & vbCrLf

                'Check obs gleich ist
                Dim str As String = Channel & Space(TitelLenght - Channel.Length) & c_Channel.getBlockData & vbCrLf
                Dim Start As Integer = rtbChannelInfo.Text.Length + TitelLenght 'Cursor-Position merken

                rtbChannelInfo.SelectionFont = f
                rtbChannelInfo.SelectionStart = Start 'Cursor Position ans Ende des Textes 
                rtbChannelInfo.SelectionLength = 0 'Nichts markieren
                rtbChannelInfo.SelectedText = str


                'TransponderID
                rtbChannelInfo.SelectionStart = Start + 3 * &H5 ' &H1
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green

                'ChannelNumber
                rtbChannelInfo.SelectionStart = Start + 3 * &H8 ' &H4
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green

                'LGChaosNumber
                rtbChannelInfo.SelectionStart = Start + 3 * &HA ' &H4
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green

                'TransponderID2
                rtbChannelInfo.SelectionStart = Start + 3 * &HC '&H8
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green

                'Favoriten
                rtbChannelInfo.SelectionStart = Start + 3 * &HE '&HA
                rtbChannelInfo.SelectionLength = 3 * 1
                rtbChannelInfo.SelectionColor = Color.Red

                'Überspringen Sperren
                rtbChannelInfo.SelectionStart = Start + 3 * &HF ' &HB
                rtbChannelInfo.SelectionLength = 3 * 1
                rtbChannelInfo.SelectionColor = Color.Red

                'ChannelServiceID
                rtbChannelInfo.SelectionStart = Start + 3 * &H10 ' &HC
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green

                'ChannelNameLenght
                rtbChannelInfo.SelectionStart = Start + 3 * &H13 '&HF
                rtbChannelInfo.SelectionLength = 3 * 1
                rtbChannelInfo.SelectionColor = Color.Green

                'ChannelName
                rtbChannelInfo.SelectionStart = Start + 3 * &H14 '&H10
                rtbChannelInfo.SelectionLength = 3 * 40
                rtbChannelInfo.SelectionColor = Color.Green

                'ChannelVideoPid
                rtbChannelInfo.SelectionStart = Start + 3 * &H3C ' &H38
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green

                'ChannelAudioPid
                rtbChannelInfo.SelectionStart = Start + 3 * &H3E '&H3A
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green

                rtbChannelInfo.SelectionLength = 0                     'Nichts markieren
                rtbChannelInfo.SelectionStart = Start + str.Length    'Cursor ans Ende

                'SaveData
                rtbChannelInfo.SelectionFont = f
                rtbChannelInfo.SelectionColor = Color.BlueViolet
                rtbChannelInfo.SelectedText = SaveChannel & Space(TitelLenght - SaveChannel.Length) & c_Channel.getBlockDatatoSave & vbCrLf




                'Check obs gleich ist
                str = Transponder & Space(TitelLenght - Transponder.Length) & t.getBlockData & vbCrLf
                Start = rtbChannelInfo.Text.Length + TitelLenght  'Cursor-Position merken

                rtbChannelInfo.SelectionFont = f
                rtbChannelInfo.SelectionStart = Start 'Cursor Position ans Ende des Textes 
                rtbChannelInfo.SelectionLength = 0 'Nichts markieren
                rtbChannelInfo.SelectedText = str

                'ID
                rtbChannelInfo.SelectionStart = Start + 3 * &HA
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green

                'Frequenz
                rtbChannelInfo.SelectionStart = Start + 3 * &HC
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green

                'NID
                rtbChannelInfo.SelectionStart = Start + 3 * &H12
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green

                'TID
                rtbChannelInfo.SelectionStart = Start + 3 * &H14
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green

                ''Symbolrate Polarisation
                'rtbChannelInfo.SelectionStart = Start + 3 * &H19
                'rtbChannelInfo.SelectionLength = 3 * 2
                'rtbChannelInfo.SelectionColor = Color.Green

                'SatelittenID
                rtbChannelInfo.SelectionStart = Start + 3 * &H24
                rtbChannelInfo.SelectionLength = 3 * 1
                rtbChannelInfo.SelectionColor = Color.Green

                rtbChannelInfo.SelectionLength = 0                     'Nichts markieren
                rtbChannelInfo.SelectionStart = Start + str.Length    'Cursor ans Ende








                'Check obs gleich ist
                str = Satelitte & Space(TitelLenght - Satelitte.Length) & s.getBlockData & vbCrLf
                Start = rtbChannelInfo.Text.Length + TitelLenght 'Cursor-Position merken

                rtbChannelInfo.SelectionFont = f
                rtbChannelInfo.SelectionStart = Start 'Cursor Position ans Ende des Textes 
                rtbChannelInfo.SelectionLength = 0 'Nichts markieren
                rtbChannelInfo.SelectedText = str

                'Satelitte
                rtbChannelInfo.SelectionStart = Start + 3 * &H0
                rtbChannelInfo.SelectionLength = 3 * 32
                rtbChannelInfo.SelectionColor = Color.Green

                'Satelitten Position
                rtbChannelInfo.SelectionStart = Start + 3 * &H20
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green


                rtbChannelInfo.SelectionLength = 0                     'Nichts markieren
                rtbChannelInfo.SelectionStart = Start + str.Length    'Cursor ans Ende









                'Check obs gleich ist
                str = LNB & Space(TitelLenght - LNB.Length) & If(l Is Nothing, "", l.getBlockData) & vbCrLf
                Start = rtbChannelInfo.Text.Length + TitelLenght 'Cursor-Position merken

                rtbChannelInfo.SelectionFont = f
                rtbChannelInfo.SelectionStart = Start 'Cursor Position ans Ende des Textes 
                rtbChannelInfo.SelectionLength = 0 'Nichts markieren
                rtbChannelInfo.SelectedText = str

                'SettingID
                rtbChannelInfo.SelectionStart = Start + 3 * &HC
                rtbChannelInfo.SelectionLength = 3 * 1
                rtbChannelInfo.SelectionColor = Color.Green

                'SatelittenID
                rtbChannelInfo.SelectionStart = Start + 3 * &H10
                rtbChannelInfo.SelectionLength = 3 * 1
                rtbChannelInfo.SelectionColor = Color.Green

                'FrequenceName
                rtbChannelInfo.SelectionStart = Start + 3 * &H14
                rtbChannelInfo.SelectionLength = 3 * 12
                rtbChannelInfo.SelectionColor = Color.Green

                'LOF1
                rtbChannelInfo.SelectionStart = Start + 3 * &H20
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green

                'LOF2
                rtbChannelInfo.SelectionStart = Start + 3 * &H24
                rtbChannelInfo.SelectionLength = 3 * 2
                rtbChannelInfo.SelectionColor = Color.Green

                rtbChannelInfo.SelectionLength = 0                     'Nichts markieren
                rtbChannelInfo.SelectionStart = Start + str.Length    'Cursor ans Ende




                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Blue
                rtbChannelInfo.SelectedText = vbCrLf & vbCrLf & "Blau = Offset in Hex     "

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = "Schwarz = noch nicht entschlüsselt     "

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Red
                rtbChannelInfo.SelectedText = "Rot = teilweise entschlüsselt     "

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Green
                rtbChannelInfo.SelectedText = "Grün = ist entschlüsselt     "

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.BlueViolet
                rtbChannelInfo.SelectedText = "Violett = Veränderter Block zum Speichern"



                rtbChannelInfo.SelectionFont = f3
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = vbCrLf & vbCrLf & "Channel Offsets"

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 05-06 und auf 0C-0D (2x? Warum?) = [1.={0} 2.={1}] ID des Transponders", c_Channel.TransponderID, c_Channel.TransponderID2)

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 08-09                            = [{0}] Kanalnummer wenn > 16384 (h4000 bzw h40 im HighByte) dann minus h4000 und es ist die Radio Kanalnummer", c_Channel.Number)

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 0A-0B                            = [{0}] LG Chaosnummer", c_Channel.LG_ChaosNumber)

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 0E                               = [{0}] Favoriten 00DCBA00 Bits mit 0 sind noch nicht entschlüsselt", c_Channel.get_strFavoriten)

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 0F                               = [skip={0} lock={1} invisible={2}] überspringen, sperren und ausblenden 00000AÜS Bits mit 0 sind noch nicht entschlüsselt", c_Channel.get_strSkip, c_Channel.get_strLock, c_Channel.get_strInvisible)

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 10-11                            = [{0}] Channel Service ID", c_Channel.ServiceID)

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 13                               = [{0}] Kanal Name Länge (Special Thanks to JoLander)", c_Channel.NameLenght)

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 14-3B                            = [{0}] Kanal Name", c_Channel.NameInFile)

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 3C-3D                            = [{0}] Channel Video Pid", c_Channel.VideoPid)

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 3E-3F                            = [{0}] Channel Audio Pid", c_Channel.AudioPid)




                rtbChannelInfo.SelectionFont = f3
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = vbCrLf & vbCrLf & "Transponder Offsets"

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 0A-0B = [{0}] Fortlaufende Nummer im TransponderBlock ist verknüpft mit der TransponderID im ChannelBlock", t.ID.ToString)

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 0C-0D = [{0}] Frequenz des Transponders", t.Frequence.ToString)

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 12-13 = [{0}] NID (Special Thanks to newLGUser)", t.NID.ToString)

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 14-15 = [{0}] TID", t.TID.ToString)

                'rtbChannelInfo.SelectionFont = f2
                'rtbChannelInfo.SelectionColor = Color.Black
                'rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 19-1A = [{0}] Symbolrate h8000 Bit ignorieren und x 2. h8000 Bit ist nicht die Polarisation!", t.Symbolrate.ToString)

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 24    = [{0}] SatelitenIndex (Value / 2) (Special Thanks to thomastomate)", t.SatelitteID.ToString)



                rtbChannelInfo.SelectionFont = f3
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = vbCrLf & vbCrLf & "Satelitten Offsets"

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 00-19 = [{0}] Satelliten Name", s.Name)

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 20-21 = [{0}] Position des Satelitten (Special Thanks to thomastomate)", s.Position)


                rtbChannelInfo.SelectionFont = f3
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = vbCrLf & vbCrLf & "LNB Offsets"

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 0C    = [{0}] SettingID", If(l Is Nothing, "", l.SettingID.ToString))

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 10    = [{0}] SatelittenID (Special Thanks to thomastomate)", If(l Is Nothing, "", l.SatelitteID.ToString))

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 14-20 = [{0}] FrequenceName", If(l Is Nothing, "", l.LNBFrequenceName))

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 20-21 = [{0}] LOF 1 (Lokale Oszillatorfrequenz)", If(l Is Nothing, "", l.LOF1.ToString))

                rtbChannelInfo.SelectionFont = f2
                rtbChannelInfo.SelectionColor = Color.Black
                rtbChannelInfo.SelectedText = String.Format(vbCrLf & "Byte 24-25 = [{0}] LOF 2", If(l Is Nothing, "", l.LOF2.ToString))

                'rtbChannelInfo.SelectionFont = f2
                'rtbChannelInfo.SelectionColor = Color.Red
                'rtbChannelInfo.SelectedText = String.Format("{0}{0}Wenn ein falscher Transponder, Satelitt angezeigt wird,{0}dann sind es höchstwahrscheinlich Sender die der TV nicht anzeigt und mit Default-Werten gefüllt sind!{0}Transponder die mit FF FF FF FF beginnen, sind glaube ich auch nur Defaults bzw Vorlagen und deren Sender werden auch nicht angezeigt!", vbCrLf)



        End Select

        f.Dispose()
        f2.Dispose()
        f3.Dispose()



    End Sub

    Private Sub butShowSatelitte_Click(sender As System.Object, e As System.EventArgs) Handles butShowSatelitte.Click
        If mytll_ReadSave Is Nothing Then Return

        Dim f As New Font("Consolas", 7, FontStyle.Bold)

        rtbChannelInfo.Clear()
        rtbChannelInfo.SelectionFont = f
        rtbChannelInfo.SelectionColor = Color.Black
        For Each s As Satelitte In mytll_ReadSave.Satelitte
            rtbChannelInfo.SelectionFont = f
            rtbChannelInfo.SelectionColor = Color.Black
            rtbChannelInfo.SelectedText = String.Format("{0}    Name={1}{2}Position={3}", s.getBlockData.TrimEnd, s.Name, Space(20 - s.Name.Length), s.Position) & vbCrLf
        Next
        f.Dispose()

    End Sub

    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
        If frmTransponderEncoding Is Nothing Then
            frmTransponderEncoding = New frmTransponderEncoding
            frmTransponderEncoding.Show(Me)
        Else

            frmTransponderEncoding.Dispose()
            frmTransponderEncoding = New frmTransponderEncoding
            frmTransponderEncoding.Show(Me)
        End If

    End Sub

    Private Sub Button3_Click(sender As System.Object, e As System.EventArgs) Handles Button3.Click
        If mytll_ReadSave Is Nothing Then Return

        Dim f As New Font("Consolas", 7, FontStyle.Bold)

        rtbChannelInfo.Clear()
        rtbChannelInfo.SelectionFont = f
        rtbChannelInfo.SelectionColor = Color.Black
        For Each l As LNB In mytll_ReadSave.LNB
            rtbChannelInfo.SelectionFont = f
            rtbChannelInfo.SelectionColor = Color.Black
            rtbChannelInfo.SelectedText = l.getBlockData.TrimEnd & vbCrLf
        Next
        f.Dispose()
    End Sub



    Private Sub chkHelp_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles chkHelp.CheckedChanged
        scMain.Panel2Collapsed = chkHelp.Checked = False
        chkHelpExtendet.Checked = If(chkHelp.Checked, False, False)
        chkHelpExtendet.Visible = chkHelp.Checked
        gbDVBSFilter.Visible = chkHelp.Checked
        If chkHelp.Checked AndAlso lvwChannels.SelectedItems.Count > 0 Then
            Call PrintDebugData()
        End If
    End Sub

    Private Sub chkHelpExtendet_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles chkHelpExtendet.CheckedChanged

        If chkHelpExtendet.Checked Then
            If frmEncode Is Nothing Then
                frmEncode = New frmEncode
            End If
            frmEncode.Show(Me)
        Else
            If frmEncode IsNot Nothing Then
                frmEncode.Dispose()
                frmEncode = Nothing
            End If
        End If

    End Sub

    Private Sub nudByteOffset_LostFocus(sender As Object, e As System.EventArgs) Handles nudByteOffset.LostFocus, nudByteValue.ValueChanged
        'Handles nudByteOffset.LostFocus, nudByteValue.ValueChanged
        If optNoFilter.Checked Then Return
        Call ReadChannels()
    End Sub



    Private Sub ShowDVBSFilter_ValueChanged(sender As System.Object, e As System.EventArgs) Handles nudByteOffset.ValueChanged, nudByteValue.ValueChanged, txtBitFilter.TextChanged
        'Handles nudByteOffset.ValueChanged, nudByteValue.ValueChanged, txtBitFilter.TextChanged

        optByteFilter.Text = String.Format(gres.GetString("optByteFilter.Text"), CByte(nudByteOffset.Value).ToString("X2"), CByte(nudByteValue.Value).ToString("X2"))
        optBitFilter.Text = String.Format(gres.GetString("optBitFilter.Text"), CByte(nudByteOffset.Value).ToString("X2"), txtBitFilter.Text)

    End Sub

    Private Sub txtBitFilter_LostFocus(sender As Object, e As System.EventArgs) Handles txtBitFilter.LostFocus
        txtBitFilter.Text = txtBitFilter.Text.PadLeft(8, CChar("0"))
        Call ReadChannels()
    End Sub


    Private Sub optFilter_Click(sender As System.Object, e As System.EventArgs) Handles optNoFilter.CheckedChanged, optByteFilter.CheckedChanged, optBitFilter.CheckedChanged
        'Handles optNoFilter.CheckedChanged, optAllFilter.CheckedChanged, optByteFilter.CheckedChanged, optBitFilter.CheckedChanged
        Call ReadChannels()
    End Sub

    '#############


    
End Class
