﻿Imports edankTLL.edank
Imports edankTLL.edank.LGTV
Imports edankTLL.edank.LGTV.Channels
Public Class frmTransponderEncoding

    Private mytll_ReadSave As tll_ReadSave
    Private chkSearchPattern() As CheckBox

    Private Sub frmTransponderEncoding_Activated(sender As Object, e As System.EventArgs) Handles Me.Activated
        nudSearchpatternSize_ValueChanged(nudSearchpatternSize, Nothing)
    End Sub

    Private Sub TransponderEncoding_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        mytll_ReadSave = DirectCast(Me.Owner, frmMain).mytll_ReadSave

        nudTransponderOffset.Maximum = tll_ReadSave.Transponder_Lenght - 3
        chkSearchPattern = New CheckBox() {chk01, chk02, chk03, chk04, chk05, chk06, chk07, chk08, chk09, chk10, chk11, chk12, chk13, chk14, chk15, chk16, chk17, chk18, chk19, chk20, chk21, chk22, chk23, chk24}

        Dim DecScale As String = Nothing
        For i As Integer = 0 To tll_ReadSave.Transponder_Lenght - 1
            DecScale &= i.ToString("X2") & " "
        Next
        DecScale = DecScale.TrimEnd
        lblScala.Text = DecScale


        Call getTransponders()
        Call nudTransponderOffset_ValueChanged(nudTransponderOffset, System.EventArgs.Empty)
        Call nudSearchpatternSize_ValueChanged(nudSearchpatternSize, System.EventArgs.Empty)
    End Sub

    Private Sub nudTransponderOffset_ValueChanged(sender As System.Object, e As System.EventArgs) Handles nudTransponderOffset.ValueChanged
        lblByte1.Text = String.Format("Byte {0}", (CByte(nudTransponderOffset.Value)).ToString("X2"))
        lblByte2.Text = String.Format("Byte {0}", (CByte(nudTransponderOffset.Value + 1)).ToString("X2"))
        lblByte3.Text = String.Format("Byte {0}", (CByte(nudTransponderOffset.Value + 2)).ToString("X2"))
    End Sub

    Private Sub nudSearchpatternSize_ValueChanged(sender As System.Object, e As System.EventArgs) Handles nudSearchpatternSize.ValueChanged, nudSearchpatternOffset.ValueChanged
        If chkSearchPattern Is Nothing Then Return
        nudSearchpatternOffset.Maximum = 23 - nudSearchpatternSize.Value + 1

        For i As Integer = 0 To 23
            chkSearchPattern(i).Checked = False
        Next

        For i As Integer = 1 To 24
            If CInt(nudSearchpatternSize.Value) >= i Then
                chkSearchPattern(Math.Min(i - 1 + CInt(nudSearchpatternOffset.Value), 23)).Checked = True
            End If

        Next
    End Sub

    Private Sub getTransponders(Optional SearchPattern As Boolean = False)
        If mytll_ReadSave Is Nothing Then Return


        tvTransponder.Nodes.Clear()


        For Each t As Transponder In mytll_ReadSave.Transponder
            If t.getBlockData.StartsWith("FF FF FF FF") Then Continue For
            'If InStr(t.getBlockData, "57 F8 2A", CompareMethod.Text) = 0 Then Continue For

            Dim nMain As New TreeNode

            If SearchPattern Then

                Dim strByte1 As String = Convert.ToString(t.DataBlock(CInt(nudTransponderOffset.Value)), 2).PadLeft(8, CChar("0"))
                Dim strByte2 As String = Convert.ToString(t.DataBlock(CInt(nudTransponderOffset.Value + 1)), 2).PadLeft(8, CChar("0"))
                Dim strByte3 As String = Convert.ToString(t.DataBlock(CInt(nudTransponderOffset.Value + 2)), 2).PadLeft(8, CChar("0"))




                Dim strBinary As String = (strByte1 & strByte2 & strByte3).PadLeft(24, CChar("0")).Substring(CInt(nudSearchpatternOffset.Value), CInt(nudSearchpatternSize.Value))



                Dim StrValue As String
                Dim Value As UInt16
                If strBinary.Length = 16 Then
                    StrValue = strBinary.Substring(8, 8) & strBinary.Substring(0, 8)
                    Value = Convert.ToUInt16(StrValue, 2)
                    If Value > &H8000 Then
                        Value = CUShort(Value - &H8000)
                    End If
                End If


                nMain.Text = strBinary & Space(26 - strBinary.Length) & t.getBlockData & String.Format("     Hex:{0} Dec:{1}", Value.ToString("X2"), Value)
            Else
                nMain.Text = Space(26) & t.getBlockData
            End If

            nMain.Nodes.Add("Channels", "Channels")
            nMain.Nodes.Add("Satellit", "Satellit")



            For Each sc As DVBS_Channel In mytll_ReadSave.getDVBSChannels_TransponderById(t.ID)
                nMain.Nodes("Channels").Nodes.Add(String.Format("{0} - {1}", sc.Number.ToString("0000"), sc.DisplayName))
            Next

            If t.SatelitteID <= mytll_ReadSave.Satelitte.Count Then
                nMain.Nodes("Satellit").Nodes.Add(mytll_ReadSave.getSatelitteByIndex(CByte(t.SatelitteID)).Name & " " & mytll_ReadSave.getSatelitteByIndex(CByte(t.SatelitteID)).Position)
            End If

            tvTransponder.Nodes.Add(nMain)

        Next
    End Sub


    Private Sub butSort_Click(sender As System.Object, e As System.EventArgs) Handles butSort.Click
        Call getTransponders(True)
        tvTransponder.BeginUpdate()
        tvTransponder.Sort()
        tvTransponder.EndUpdate()
    End Sub





End Class